/*
 * Copyright 2014-2016 Freescale Semiconductor, Inc.
 * Copyright 2017 NXP
 *
 * SPDX-License-Identifier: BSD-3-Clause
 */

#ifndef _TALKER_LISTENER_AUDIO_MULTI_AAF_H_
#define _TALKER_LISTENER_AUDIO_MULTI_AAF_H_

#define AEM_ENTITY_MODEL_ID				0x00049f0000090001 /* to be incremented by one upon change in the structure of entity model  - 17722_1-6.2.1.9 */


/* Entity config */
#define AEM_CFG_ENTITY_NAME				"NXP AVB device"
#define AEM_CFG_ENTITY_GROUP_NAME			"NXP demo"
#define AEM_CFG_ENTITY_SERIAL				"0000000000000001"
#define AEM_CFG_ENTITY_VENDOR_NAME			0
#define AEM_CFG_ENTITY_MODEL_NAME			1
#define AEM_CFG_ENTITY_FW_VERSION			"0.0.1"
#define AEM_CFG_ENTITY_CAPABILITIES			(ADP_ENTITY_CLASS_A_SUPPORTED | ADP_ENTITY_CLASS_B_SUPPORTED | ADP_ENTITY_GPTP_SUPPORTED | ADP_ENTITY_AEM_SUPPORTED)
#define AEM_CFG_ENTITY_TALKER_CAPABILITIES		(ADP_TALKER_AUDIO_SOURCE | ADP_TALKER_MEDIA_CLOCK_SOURCE | ADP_TALKER_IMPLEMENTED)
#define AEM_CFG_ENTITY_LISTENER_CAPABILITIES		(ADP_LISTENER_AUDIO_SINK | ADP_LISTENER_MEDIA_CLOCK_SINK | ADP_LISTENER_IMPLEMENTED)
#define AEM_CFG_ENTITY_CONTROLLER_CAPABILITIES		0
#define AEM_CFG_ENTITY_CURRENT_CONF			0


/* Configuration config */
#define AEM_CFG_CONFIG_NAME_0				"Unique configuration"
#define AEM_CFG_CONFIG_LOC_DESC_0			7


#define AEM_CFG_CONFIG_DESCRIPTORS {AEM_CFG_CONFIG_DESCRIPTOR(0)}


/* Audio unit config */
#define AEM_CFG_AUDIO_UNIT_NAME_0			"Audio unit"
#define AEM_CFG_AUDIO_UNIT_LOC_DESC_0			7
#define AEM_CFG_AUDIO_UNIT_CLK_DOMAIN_IDX_0		0
#define AEM_CFG_AUDIO_UNIT_NB_STREAM_IN_PORT_0		1
#define AEM_CFG_AUDIO_UNIT_BASE_STREAM_IN_PORT_0	0
#define AEM_CFG_AUDIO_UNIT_NB_STREAM_OUT_PORT_0		1
#define AEM_CFG_AUDIO_UNIT_BASE_STREAM_OUT_PORT_0	0
#define AEM_CFG_AUDIO_UNIT_NB_EXT_IN_PORT_0		8
#define AEM_CFG_AUDIO_UNIT_BASE_EXT_IN_PORT_0		0
#define AEM_CFG_AUDIO_UNIT_NB_EXT_OUT_PORT_0		8
#define AEM_CFG_AUDIO_UNIT_BASE_EXT_OUT_PORT_0		0
#define AEM_CFG_AUDIO_UNIT_NB_INT_IN_PORT_0		0
#define AEM_CFG_AUDIO_UNIT_BASE_INT_IN_PORT_0		0
#define AEM_CFG_AUDIO_UNIT_NB_INT_OUT_PORT_0		0
#define AEM_CFG_AUDIO_UNIT_BASE_INT_OUT_PORT_0		0
#define AEM_CFG_AUDIO_UNIT_NB_CONTROLS_0		1
#define AEM_CFG_AUDIO_UNIT_BASE_CONTROLS_0		0
#define AEM_CFG_AUDIO_UNIT_NB_SIGNAL_SEL_0		0
#define AEM_CFG_AUDIO_UNIT_BASE_SIGNAL_SEL_0		0
#define AEM_CFG_AUDIO_UNIT_NB_MIXERS_0			0
#define AEM_CFG_AUDIO_UNIT_BASE_MIXER_0			0
#define AEM_CFG_AUDIO_UNIT_NB_MATRICES_0		0
#define AEM_CFG_AUDIO_UNIT_BASE_MATRIX_0		0
#define AEM_CFG_AUDIO_UNIT_NB_SPLITTERS_0		0
#define AEM_CFG_AUDIO_UNIT_BASE_SPLITTER_0		0
#define AEM_CFG_AUDIO_UNIT_NB_COMBINERS_0		0
#define AEM_CFG_AUDIO_UNIT_BASE_COMBINER_0		0
#define AEM_CFG_AUDIO_UNIT_NB_MUX_0			0
#define AEM_CFG_AUDIO_UNIT_BASE_MUX_0			0
#define AEM_CFG_AUDIO_UNIT_NB_DEMUX_0			0
#define AEM_CFG_AUDIO_UNIT_BASE_DEMUX_0			0
#define AEM_CFG_AUDIO_UNIT_NB_TRANSCODERS_0		0
#define AEM_CFG_AUDIO_UNIT_BASE_TRANSCODERS_0		0
#define AEM_CFG_AUDIO_UNIT_NB_CONTROL_BLOCKS_0		0
#define AEM_CFG_AUDIO_UNIT_BASE_CONTROL_BLOCK_0		0
#define AEM_CFG_AUDIO_UNIT_CUR_SAMPLING_RATE_0		48000
#define AEM_CFG_AUDIO_UNIT_SAMP_RATES_COUNT_0		1
#define AEM_CFG_AUDIO_UNIT_SAMP_RATES_0			{ htonl(48000) }


#define AEM_CFG_AUDIO_UNIT_DESCRIPTORS {AEM_CFG_AUDIO_UNIT_DESCRIPTOR(0)}


/* Stream input config */
#define AEM_CFG_STREAM_INPUT_NAME_0			"Stream input 0"
#define AEM_CFG_STREAM_INPUT_LOC_DESC_0			7
#define AEM_CFG_STREAM_INPUT_CLOCK_DOMAIN_IDX_0		0
#define AEM_CFG_STREAM_INPUT_STREAM_FLAGS_0		(AEM_STREAM_FLAG_CLASS_A | AEM_STREAM_FLAG_CLASS_B)
#define AEM_CFG_STREAM_INPUT_CURRENT_FORMAT_0		0x0205021800806000 //7.3.2
#define AEM_CFG_STREAM_INPUT_NB_FORMATS_0		1
#define AEM_CFG_STREAM_INPUT_BACKUP_TALKER_ENTITY_0_0	0
#define AEM_CFG_STREAM_INPUT_BACKUP_TALKER_UNIQUE_0_0	0
#define AEM_CFG_STREAM_INPUT_BACKUP_TALKER_ENTITY_1_0	0
#define AEM_CFG_STREAM_INPUT_BACKUP_TALKER_UNIQUE_1_0	0
#define AEM_CFG_STREAM_INPUT_BACKUP_TALKER_ENTITY_2_0	0
#define AEM_CFG_STREAM_INPUT_BACKUP_TALKER_UNIQUE_2_0	0
#define AEM_CFG_STREAM_INPUT_BACKEDUP_TALKER_ENTITY_0	0
#define AEM_CFG_STREAM_INPUT_BACKEDUP_TALKER_UNIQUE_0	0
#define AEM_CFG_STREAM_INPUT_AVB_ITF_INDEX_0		0
#define AEM_CFG_STREAM_INPUT_BUFFER_LENGTH_0		0
#define AEM_CFG_STREAM_INPUT_FORMATS_0			{ htonll(AEM_CFG_STREAM_INPUT_CURRENT_FORMAT_0) }

#define AEM_CFG_STREAM_INPUT_NAME_1			"Stream input 1"
#define AEM_CFG_STREAM_INPUT_LOC_DESC_1			AEM_CFG_STREAM_INPUT_LOC_DESC_0
#define AEM_CFG_STREAM_INPUT_CLOCK_DOMAIN_IDX_1		AEM_CFG_STREAM_INPUT_CLOCK_DOMAIN_IDX_0
#define AEM_CFG_STREAM_INPUT_STREAM_FLAGS_1		AEM_CFG_STREAM_INPUT_STREAM_FLAGS_0
#define AEM_CFG_STREAM_INPUT_CURRENT_FORMAT_1		AEM_CFG_STREAM_INPUT_CURRENT_FORMAT_0
#define AEM_CFG_STREAM_INPUT_NB_FORMATS_1		AEM_CFG_STREAM_INPUT_NB_FORMATS_0
#define AEM_CFG_STREAM_INPUT_BACKUP_TALKER_ENTITY_0_1	AEM_CFG_STREAM_INPUT_BACKUP_TALKER_ENTITY_0_0
#define AEM_CFG_STREAM_INPUT_BACKUP_TALKER_UNIQUE_0_1	AEM_CFG_STREAM_INPUT_BACKUP_TALKER_UNIQUE_0_0
#define AEM_CFG_STREAM_INPUT_BACKUP_TALKER_ENTITY_1_1	AEM_CFG_STREAM_INPUT_BACKUP_TALKER_ENTITY_1_0
#define AEM_CFG_STREAM_INPUT_BACKUP_TALKER_UNIQUE_1_1	AEM_CFG_STREAM_INPUT_BACKUP_TALKER_UNIQUE_1_0
#define AEM_CFG_STREAM_INPUT_BACKUP_TALKER_ENTITY_2_1	AEM_CFG_STREAM_INPUT_BACKUP_TALKER_ENTITY_2_0
#define AEM_CFG_STREAM_INPUT_BACKUP_TALKER_UNIQUE_2_1	AEM_CFG_STREAM_INPUT_BACKUP_TALKER_UNIQUE_2_0
#define AEM_CFG_STREAM_INPUT_BACKEDUP_TALKER_ENTITY_1	AEM_CFG_STREAM_INPUT_BACKEDUP_TALKER_ENTITY_0
#define AEM_CFG_STREAM_INPUT_BACKEDUP_TALKER_UNIQUE_1	AEM_CFG_STREAM_INPUT_BACKEDUP_TALKER_UNIQUE_0
#define AEM_CFG_STREAM_INPUT_AVB_ITF_INDEX_1		AEM_CFG_STREAM_INPUT_AVB_ITF_INDEX_0
#define AEM_CFG_STREAM_INPUT_BUFFER_LENGTH_1		AEM_CFG_STREAM_INPUT_BUFFER_LENGTH_0
#define AEM_CFG_STREAM_INPUT_FORMATS_1			AEM_CFG_STREAM_INPUT_FORMATS_0

#define AEM_CFG_STREAM_INPUT_NAME_2			"Stream input 2"
#define AEM_CFG_STREAM_INPUT_LOC_DESC_2			AEM_CFG_STREAM_INPUT_LOC_DESC_0
#define AEM_CFG_STREAM_INPUT_CLOCK_DOMAIN_IDX_2		AEM_CFG_STREAM_INPUT_CLOCK_DOMAIN_IDX_0
#define AEM_CFG_STREAM_INPUT_STREAM_FLAGS_2		AEM_CFG_STREAM_INPUT_STREAM_FLAGS_0
#define AEM_CFG_STREAM_INPUT_CURRENT_FORMAT_2		AEM_CFG_STREAM_INPUT_CURRENT_FORMAT_0
#define AEM_CFG_STREAM_INPUT_NB_FORMATS_2		AEM_CFG_STREAM_INPUT_NB_FORMATS_0
#define AEM_CFG_STREAM_INPUT_BACKUP_TALKER_ENTITY_0_2	AEM_CFG_STREAM_INPUT_BACKUP_TALKER_ENTITY_0_0
#define AEM_CFG_STREAM_INPUT_BACKUP_TALKER_UNIQUE_0_2	AEM_CFG_STREAM_INPUT_BACKUP_TALKER_UNIQUE_0_0
#define AEM_CFG_STREAM_INPUT_BACKUP_TALKER_ENTITY_1_2	AEM_CFG_STREAM_INPUT_BACKUP_TALKER_ENTITY_1_0
#define AEM_CFG_STREAM_INPUT_BACKUP_TALKER_UNIQUE_1_2	AEM_CFG_STREAM_INPUT_BACKUP_TALKER_UNIQUE_1_0
#define AEM_CFG_STREAM_INPUT_BACKUP_TALKER_ENTITY_2_2	AEM_CFG_STREAM_INPUT_BACKUP_TALKER_ENTITY_2_0
#define AEM_CFG_STREAM_INPUT_BACKUP_TALKER_UNIQUE_2_2	AEM_CFG_STREAM_INPUT_BACKUP_TALKER_UNIQUE_2_0
#define AEM_CFG_STREAM_INPUT_BACKEDUP_TALKER_ENTITY_2	AEM_CFG_STREAM_INPUT_BACKEDUP_TALKER_ENTITY_0
#define AEM_CFG_STREAM_INPUT_BACKEDUP_TALKER_UNIQUE_2	AEM_CFG_STREAM_INPUT_BACKEDUP_TALKER_UNIQUE_0
#define AEM_CFG_STREAM_INPUT_AVB_ITF_INDEX_2		AEM_CFG_STREAM_INPUT_AVB_ITF_INDEX_0
#define AEM_CFG_STREAM_INPUT_BUFFER_LENGTH_2		AEM_CFG_STREAM_INPUT_BUFFER_LENGTH_0
#define AEM_CFG_STREAM_INPUT_FORMATS_2			AEM_CFG_STREAM_INPUT_FORMATS_0

#define AEM_CFG_STREAM_INPUT_NAME_3			"Stream input 3"
#define AEM_CFG_STREAM_INPUT_LOC_DESC_3			AEM_CFG_STREAM_INPUT_LOC_DESC_0
#define AEM_CFG_STREAM_INPUT_CLOCK_DOMAIN_IDX_3		AEM_CFG_STREAM_INPUT_CLOCK_DOMAIN_IDX_0
#define AEM_CFG_STREAM_INPUT_STREAM_FLAGS_3		AEM_CFG_STREAM_INPUT_STREAM_FLAGS_0
#define AEM_CFG_STREAM_INPUT_CURRENT_FORMAT_3		AEM_CFG_STREAM_INPUT_CURRENT_FORMAT_0
#define AEM_CFG_STREAM_INPUT_NB_FORMATS_3		AEM_CFG_STREAM_INPUT_NB_FORMATS_0
#define AEM_CFG_STREAM_INPUT_BACKUP_TALKER_ENTITY_0_3	AEM_CFG_STREAM_INPUT_BACKUP_TALKER_ENTITY_0_0
#define AEM_CFG_STREAM_INPUT_BACKUP_TALKER_UNIQUE_0_3	AEM_CFG_STREAM_INPUT_BACKUP_TALKER_UNIQUE_0_0
#define AEM_CFG_STREAM_INPUT_BACKUP_TALKER_ENTITY_1_3	AEM_CFG_STREAM_INPUT_BACKUP_TALKER_ENTITY_1_0
#define AEM_CFG_STREAM_INPUT_BACKUP_TALKER_UNIQUE_1_3	AEM_CFG_STREAM_INPUT_BACKUP_TALKER_UNIQUE_1_0
#define AEM_CFG_STREAM_INPUT_BACKUP_TALKER_ENTITY_2_3	AEM_CFG_STREAM_INPUT_BACKUP_TALKER_ENTITY_2_0
#define AEM_CFG_STREAM_INPUT_BACKUP_TALKER_UNIQUE_2_3	AEM_CFG_STREAM_INPUT_BACKUP_TALKER_UNIQUE_2_0
#define AEM_CFG_STREAM_INPUT_BACKEDUP_TALKER_ENTITY_3	AEM_CFG_STREAM_INPUT_BACKEDUP_TALKER_ENTITY_0
#define AEM_CFG_STREAM_INPUT_BACKEDUP_TALKER_UNIQUE_3	AEM_CFG_STREAM_INPUT_BACKEDUP_TALKER_UNIQUE_0
#define AEM_CFG_STREAM_INPUT_AVB_ITF_INDEX_3		AEM_CFG_STREAM_INPUT_AVB_ITF_INDEX_0
#define AEM_CFG_STREAM_INPUT_BUFFER_LENGTH_3		AEM_CFG_STREAM_INPUT_BUFFER_LENGTH_0
#define AEM_CFG_STREAM_INPUT_FORMATS_3			AEM_CFG_STREAM_INPUT_FORMATS_0

#define AEM_CFG_STREAM_INPUT_NAME_4			"Stream input 4"
#define AEM_CFG_STREAM_INPUT_LOC_DESC_4			AEM_CFG_STREAM_INPUT_LOC_DESC_0
#define AEM_CFG_STREAM_INPUT_CLOCK_DOMAIN_IDX_4		AEM_CFG_STREAM_INPUT_CLOCK_DOMAIN_IDX_0
#define AEM_CFG_STREAM_INPUT_STREAM_FLAGS_4		AEM_CFG_STREAM_INPUT_STREAM_FLAGS_0
#define AEM_CFG_STREAM_INPUT_CURRENT_FORMAT_4		AEM_CFG_STREAM_INPUT_CURRENT_FORMAT_0
#define AEM_CFG_STREAM_INPUT_NB_FORMATS_4		AEM_CFG_STREAM_INPUT_NB_FORMATS_0
#define AEM_CFG_STREAM_INPUT_BACKUP_TALKER_ENTITY_0_4	AEM_CFG_STREAM_INPUT_BACKUP_TALKER_ENTITY_0_0
#define AEM_CFG_STREAM_INPUT_BACKUP_TALKER_UNIQUE_0_4	AEM_CFG_STREAM_INPUT_BACKUP_TALKER_UNIQUE_0_0
#define AEM_CFG_STREAM_INPUT_BACKUP_TALKER_ENTITY_1_4	AEM_CFG_STREAM_INPUT_BACKUP_TALKER_ENTITY_1_0
#define AEM_CFG_STREAM_INPUT_BACKUP_TALKER_UNIQUE_1_4	AEM_CFG_STREAM_INPUT_BACKUP_TALKER_UNIQUE_1_0
#define AEM_CFG_STREAM_INPUT_BACKUP_TALKER_ENTITY_2_4	AEM_CFG_STREAM_INPUT_BACKUP_TALKER_ENTITY_2_0
#define AEM_CFG_STREAM_INPUT_BACKUP_TALKER_UNIQUE_2_4	AEM_CFG_STREAM_INPUT_BACKUP_TALKER_UNIQUE_2_0
#define AEM_CFG_STREAM_INPUT_BACKEDUP_TALKER_ENTITY_4	AEM_CFG_STREAM_INPUT_BACKEDUP_TALKER_ENTITY_0
#define AEM_CFG_STREAM_INPUT_BACKEDUP_TALKER_UNIQUE_4	AEM_CFG_STREAM_INPUT_BACKEDUP_TALKER_UNIQUE_0
#define AEM_CFG_STREAM_INPUT_AVB_ITF_INDEX_4		AEM_CFG_STREAM_INPUT_AVB_ITF_INDEX_0
#define AEM_CFG_STREAM_INPUT_BUFFER_LENGTH_4		AEM_CFG_STREAM_INPUT_BUFFER_LENGTH_0
#define AEM_CFG_STREAM_INPUT_FORMATS_4			AEM_CFG_STREAM_INPUT_FORMATS_0

#define AEM_CFG_STREAM_INPUT_NAME_5			"Stream input 5"
#define AEM_CFG_STREAM_INPUT_LOC_DESC_5			AEM_CFG_STREAM_INPUT_LOC_DESC_0
#define AEM_CFG_STREAM_INPUT_CLOCK_DOMAIN_IDX_5		AEM_CFG_STREAM_INPUT_CLOCK_DOMAIN_IDX_0
#define AEM_CFG_STREAM_INPUT_STREAM_FLAGS_5		AEM_CFG_STREAM_INPUT_STREAM_FLAGS_0
#define AEM_CFG_STREAM_INPUT_CURRENT_FORMAT_5		AEM_CFG_STREAM_INPUT_CURRENT_FORMAT_0
#define AEM_CFG_STREAM_INPUT_NB_FORMATS_5		AEM_CFG_STREAM_INPUT_NB_FORMATS_0
#define AEM_CFG_STREAM_INPUT_BACKUP_TALKER_ENTITY_0_5	AEM_CFG_STREAM_INPUT_BACKUP_TALKER_ENTITY_0_0
#define AEM_CFG_STREAM_INPUT_BACKUP_TALKER_UNIQUE_0_5	AEM_CFG_STREAM_INPUT_BACKUP_TALKER_UNIQUE_0_0
#define AEM_CFG_STREAM_INPUT_BACKUP_TALKER_ENTITY_1_5	AEM_CFG_STREAM_INPUT_BACKUP_TALKER_ENTITY_1_0
#define AEM_CFG_STREAM_INPUT_BACKUP_TALKER_UNIQUE_1_5	AEM_CFG_STREAM_INPUT_BACKUP_TALKER_UNIQUE_1_0
#define AEM_CFG_STREAM_INPUT_BACKUP_TALKER_ENTITY_2_5	AEM_CFG_STREAM_INPUT_BACKUP_TALKER_ENTITY_2_0
#define AEM_CFG_STREAM_INPUT_BACKUP_TALKER_UNIQUE_2_5	AEM_CFG_STREAM_INPUT_BACKUP_TALKER_UNIQUE_2_0
#define AEM_CFG_STREAM_INPUT_BACKEDUP_TALKER_ENTITY_5	AEM_CFG_STREAM_INPUT_BACKEDUP_TALKER_ENTITY_0
#define AEM_CFG_STREAM_INPUT_BACKEDUP_TALKER_UNIQUE_5	AEM_CFG_STREAM_INPUT_BACKEDUP_TALKER_UNIQUE_0
#define AEM_CFG_STREAM_INPUT_AVB_ITF_INDEX_5		AEM_CFG_STREAM_INPUT_AVB_ITF_INDEX_0
#define AEM_CFG_STREAM_INPUT_BUFFER_LENGTH_5		AEM_CFG_STREAM_INPUT_BUFFER_LENGTH_0
#define AEM_CFG_STREAM_INPUT_FORMATS_5			AEM_CFG_STREAM_INPUT_FORMATS_0

#define AEM_CFG_STREAM_INPUT_NAME_6			"Stream input 6"
#define AEM_CFG_STREAM_INPUT_LOC_DESC_6			AEM_CFG_STREAM_INPUT_LOC_DESC_0
#define AEM_CFG_STREAM_INPUT_CLOCK_DOMAIN_IDX_6		AEM_CFG_STREAM_INPUT_CLOCK_DOMAIN_IDX_0
#define AEM_CFG_STREAM_INPUT_STREAM_FLAGS_6		AEM_CFG_STREAM_INPUT_STREAM_FLAGS_0
#define AEM_CFG_STREAM_INPUT_CURRENT_FORMAT_6		AEM_CFG_STREAM_INPUT_CURRENT_FORMAT_0
#define AEM_CFG_STREAM_INPUT_NB_FORMATS_6		AEM_CFG_STREAM_INPUT_NB_FORMATS_0
#define AEM_CFG_STREAM_INPUT_BACKUP_TALKER_ENTITY_0_6	AEM_CFG_STREAM_INPUT_BACKUP_TALKER_ENTITY_0_0
#define AEM_CFG_STREAM_INPUT_BACKUP_TALKER_UNIQUE_0_6	AEM_CFG_STREAM_INPUT_BACKUP_TALKER_UNIQUE_0_0
#define AEM_CFG_STREAM_INPUT_BACKUP_TALKER_ENTITY_1_6	AEM_CFG_STREAM_INPUT_BACKUP_TALKER_ENTITY_1_0
#define AEM_CFG_STREAM_INPUT_BACKUP_TALKER_UNIQUE_1_6	AEM_CFG_STREAM_INPUT_BACKUP_TALKER_UNIQUE_1_0
#define AEM_CFG_STREAM_INPUT_BACKUP_TALKER_ENTITY_2_6	AEM_CFG_STREAM_INPUT_BACKUP_TALKER_ENTITY_2_0
#define AEM_CFG_STREAM_INPUT_BACKUP_TALKER_UNIQUE_2_6	AEM_CFG_STREAM_INPUT_BACKUP_TALKER_UNIQUE_2_0
#define AEM_CFG_STREAM_INPUT_BACKEDUP_TALKER_ENTITY_6	AEM_CFG_STREAM_INPUT_BACKEDUP_TALKER_ENTITY_0
#define AEM_CFG_STREAM_INPUT_BACKEDUP_TALKER_UNIQUE_6	AEM_CFG_STREAM_INPUT_BACKEDUP_TALKER_UNIQUE_0
#define AEM_CFG_STREAM_INPUT_AVB_ITF_INDEX_6		AEM_CFG_STREAM_INPUT_AVB_ITF_INDEX_0
#define AEM_CFG_STREAM_INPUT_BUFFER_LENGTH_6		AEM_CFG_STREAM_INPUT_BUFFER_LENGTH_0
#define AEM_CFG_STREAM_INPUT_FORMATS_6			AEM_CFG_STREAM_INPUT_FORMATS_0

#define AEM_CFG_STREAM_INPUT_NAME_7			"Stream input 7"
#define AEM_CFG_STREAM_INPUT_LOC_DESC_7			AEM_CFG_STREAM_INPUT_LOC_DESC_0
#define AEM_CFG_STREAM_INPUT_CLOCK_DOMAIN_IDX_7		AEM_CFG_STREAM_INPUT_CLOCK_DOMAIN_IDX_0
#define AEM_CFG_STREAM_INPUT_STREAM_FLAGS_7		AEM_CFG_STREAM_INPUT_STREAM_FLAGS_0
#define AEM_CFG_STREAM_INPUT_CURRENT_FORMAT_7		AEM_CFG_STREAM_INPUT_CURRENT_FORMAT_0
#define AEM_CFG_STREAM_INPUT_NB_FORMATS_7		AEM_CFG_STREAM_INPUT_NB_FORMATS_0
#define AEM_CFG_STREAM_INPUT_BACKUP_TALKER_ENTITY_0_7	AEM_CFG_STREAM_INPUT_BACKUP_TALKER_ENTITY_0_0
#define AEM_CFG_STREAM_INPUT_BACKUP_TALKER_UNIQUE_0_7	AEM_CFG_STREAM_INPUT_BACKUP_TALKER_UNIQUE_0_0
#define AEM_CFG_STREAM_INPUT_BACKUP_TALKER_ENTITY_1_7	AEM_CFG_STREAM_INPUT_BACKUP_TALKER_ENTITY_1_0
#define AEM_CFG_STREAM_INPUT_BACKUP_TALKER_UNIQUE_1_7	AEM_CFG_STREAM_INPUT_BACKUP_TALKER_UNIQUE_1_0
#define AEM_CFG_STREAM_INPUT_BACKUP_TALKER_ENTITY_2_7	AEM_CFG_STREAM_INPUT_BACKUP_TALKER_ENTITY_2_0
#define AEM_CFG_STREAM_INPUT_BACKUP_TALKER_UNIQUE_2_7	AEM_CFG_STREAM_INPUT_BACKUP_TALKER_UNIQUE_2_0
#define AEM_CFG_STREAM_INPUT_BACKEDUP_TALKER_ENTITY_7	AEM_CFG_STREAM_INPUT_BACKEDUP_TALKER_ENTITY_0
#define AEM_CFG_STREAM_INPUT_BACKEDUP_TALKER_UNIQUE_7	AEM_CFG_STREAM_INPUT_BACKEDUP_TALKER_UNIQUE_0
#define AEM_CFG_STREAM_INPUT_AVB_ITF_INDEX_7		AEM_CFG_STREAM_INPUT_AVB_ITF_INDEX_0
#define AEM_CFG_STREAM_INPUT_BUFFER_LENGTH_7		AEM_CFG_STREAM_INPUT_BUFFER_LENGTH_0
#define AEM_CFG_STREAM_INPUT_FORMATS_7			AEM_CFG_STREAM_INPUT_FORMATS_0

#define AEM_CFG_STREAM_INPUT_DESCRIPTORS {	\
						AEM_CFG_STREAM_INPUT_DESCRIPTOR(0), AEM_CFG_STREAM_INPUT_DESCRIPTOR(1), AEM_CFG_STREAM_INPUT_DESCRIPTOR(2), AEM_CFG_STREAM_INPUT_DESCRIPTOR(3), \
						AEM_CFG_STREAM_INPUT_DESCRIPTOR(4), AEM_CFG_STREAM_INPUT_DESCRIPTOR(5), AEM_CFG_STREAM_INPUT_DESCRIPTOR(6), AEM_CFG_STREAM_INPUT_DESCRIPTOR(7), \
					}

/* Stream output config */
#define AEM_CFG_STREAM_OUTPUT_NAME_0			"Stream output 0"
#define AEM_CFG_STREAM_OUTPUT_LOC_DESC_0		7
#define AEM_CFG_STREAM_OUTPUT_CLOCK_DOMAIN_IDX_0	0
#define AEM_CFG_STREAM_OUTPUT_STREAM_FLAGS_0		(AEM_STREAM_FLAG_CLASS_A | AEM_STREAM_FLAG_CLASS_B)
#define AEM_CFG_STREAM_OUTPUT_CURRENT_FORMAT_0		0x0205021800806000 //7.3.2
#define AEM_CFG_STREAM_OUTPUT_NB_FORMATS_0		1
#define AEM_CFG_STREAM_OUTPUT_BACKUP_TALKER_ENTITY_0_0	0
#define AEM_CFG_STREAM_OUTPUT_BACKUP_TALKER_UNIQUE_0_0	0
#define AEM_CFG_STREAM_OUTPUT_BACKUP_TALKER_ENTITY_1_0	0
#define AEM_CFG_STREAM_OUTPUT_BACKUP_TALKER_UNIQUE_1_0	0
#define AEM_CFG_STREAM_OUTPUT_BACKUP_TALKER_ENTITY_2_0	0
#define AEM_CFG_STREAM_OUTPUT_BACKUP_TALKER_UNIQUE_2_0	0
#define AEM_CFG_STREAM_OUTPUT_BACKEDUP_TALKER_ENTITY_0	0
#define AEM_CFG_STREAM_OUTPUT_BACKEDUP_TALKER_UNIQUE_0	0
#define AEM_CFG_STREAM_OUTPUT_AVB_ITF_INDEX_0		0
#define AEM_CFG_STREAM_OUTPUT_BUFFER_LENGTH_0		0
#define AEM_CFG_STREAM_OUTPUT_FORMATS_0			{ htonll(AEM_CFG_STREAM_OUTPUT_CURRENT_FORMAT_0) }

#define AEM_CFG_STREAM_OUTPUT_NAME_1			"Stream output 1"
#define AEM_CFG_STREAM_OUTPUT_LOC_DESC_1		AEM_CFG_STREAM_OUTPUT_LOC_DESC_0
#define AEM_CFG_STREAM_OUTPUT_CLOCK_DOMAIN_IDX_1	AEM_CFG_STREAM_OUTPUT_CLOCK_DOMAIN_IDX_0
#define AEM_CFG_STREAM_OUTPUT_STREAM_FLAGS_1		AEM_CFG_STREAM_OUTPUT_STREAM_FLAGS_0
#define AEM_CFG_STREAM_OUTPUT_CURRENT_FORMAT_1		AEM_CFG_STREAM_OUTPUT_CURRENT_FORMAT_0
#define AEM_CFG_STREAM_OUTPUT_NB_FORMATS_1		AEM_CFG_STREAM_OUTPUT_NB_FORMATS_0
#define AEM_CFG_STREAM_OUTPUT_BACKUP_TALKER_ENTITY_0_1	AEM_CFG_STREAM_OUTPUT_BACKUP_TALKER_ENTITY_0_0
#define AEM_CFG_STREAM_OUTPUT_BACKUP_TALKER_UNIQUE_0_1	AEM_CFG_STREAM_OUTPUT_BACKUP_TALKER_UNIQUE_0_0
#define AEM_CFG_STREAM_OUTPUT_BACKUP_TALKER_ENTITY_1_1	AEM_CFG_STREAM_OUTPUT_BACKUP_TALKER_ENTITY_1_0
#define AEM_CFG_STREAM_OUTPUT_BACKUP_TALKER_UNIQUE_1_1	AEM_CFG_STREAM_OUTPUT_BACKUP_TALKER_UNIQUE_1_0
#define AEM_CFG_STREAM_OUTPUT_BACKUP_TALKER_ENTITY_2_1	AEM_CFG_STREAM_OUTPUT_BACKUP_TALKER_ENTITY_2_0
#define AEM_CFG_STREAM_OUTPUT_BACKUP_TALKER_UNIQUE_2_1	AEM_CFG_STREAM_OUTPUT_BACKUP_TALKER_UNIQUE_2_0
#define AEM_CFG_STREAM_OUTPUT_BACKEDUP_TALKER_ENTITY_1	AEM_CFG_STREAM_OUTPUT_BACKEDUP_TALKER_ENTITY_0
#define AEM_CFG_STREAM_OUTPUT_BACKEDUP_TALKER_UNIQUE_1	AEM_CFG_STREAM_OUTPUT_BACKEDUP_TALKER_UNIQUE_0
#define AEM_CFG_STREAM_OUTPUT_AVB_ITF_INDEX_1		AEM_CFG_STREAM_OUTPUT_AVB_ITF_INDEX_0
#define AEM_CFG_STREAM_OUTPUT_BUFFER_LENGTH_1		AEM_CFG_STREAM_OUTPUT_BUFFER_LENGTH_0
#define AEM_CFG_STREAM_OUTPUT_FORMATS_1			AEM_CFG_STREAM_OUTPUT_FORMATS_0

#define AEM_CFG_STREAM_OUTPUT_NAME_2			"Stream output 2"
#define AEM_CFG_STREAM_OUTPUT_LOC_DESC_2		AEM_CFG_STREAM_OUTPUT_LOC_DESC_0
#define AEM_CFG_STREAM_OUTPUT_CLOCK_DOMAIN_IDX_2	AEM_CFG_STREAM_OUTPUT_CLOCK_DOMAIN_IDX_0
#define AEM_CFG_STREAM_OUTPUT_STREAM_FLAGS_2		AEM_CFG_STREAM_OUTPUT_STREAM_FLAGS_0
#define AEM_CFG_STREAM_OUTPUT_CURRENT_FORMAT_2		AEM_CFG_STREAM_OUTPUT_CURRENT_FORMAT_0
#define AEM_CFG_STREAM_OUTPUT_NB_FORMATS_2		AEM_CFG_STREAM_OUTPUT_NB_FORMATS_0
#define AEM_CFG_STREAM_OUTPUT_BACKUP_TALKER_ENTITY_0_2	AEM_CFG_STREAM_OUTPUT_BACKUP_TALKER_ENTITY_0_0
#define AEM_CFG_STREAM_OUTPUT_BACKUP_TALKER_UNIQUE_0_2	AEM_CFG_STREAM_OUTPUT_BACKUP_TALKER_UNIQUE_0_0
#define AEM_CFG_STREAM_OUTPUT_BACKUP_TALKER_ENTITY_1_2	AEM_CFG_STREAM_OUTPUT_BACKUP_TALKER_ENTITY_1_0
#define AEM_CFG_STREAM_OUTPUT_BACKUP_TALKER_UNIQUE_1_2	AEM_CFG_STREAM_OUTPUT_BACKUP_TALKER_UNIQUE_1_0
#define AEM_CFG_STREAM_OUTPUT_BACKUP_TALKER_ENTITY_2_2	AEM_CFG_STREAM_OUTPUT_BACKUP_TALKER_ENTITY_2_0
#define AEM_CFG_STREAM_OUTPUT_BACKUP_TALKER_UNIQUE_2_2	AEM_CFG_STREAM_OUTPUT_BACKUP_TALKER_UNIQUE_2_0
#define AEM_CFG_STREAM_OUTPUT_BACKEDUP_TALKER_ENTITY_2	AEM_CFG_STREAM_OUTPUT_BACKEDUP_TALKER_ENTITY_0
#define AEM_CFG_STREAM_OUTPUT_BACKEDUP_TALKER_UNIQUE_2	AEM_CFG_STREAM_OUTPUT_BACKEDUP_TALKER_UNIQUE_0
#define AEM_CFG_STREAM_OUTPUT_AVB_ITF_INDEX_2		AEM_CFG_STREAM_OUTPUT_AVB_ITF_INDEX_0
#define AEM_CFG_STREAM_OUTPUT_BUFFER_LENGTH_2		AEM_CFG_STREAM_OUTPUT_BUFFER_LENGTH_0
#define AEM_CFG_STREAM_OUTPUT_FORMATS_2			AEM_CFG_STREAM_OUTPUT_FORMATS_0

#define AEM_CFG_STREAM_OUTPUT_NAME_3			"Stream output 3"
#define AEM_CFG_STREAM_OUTPUT_LOC_DESC_3		AEM_CFG_STREAM_OUTPUT_LOC_DESC_0
#define AEM_CFG_STREAM_OUTPUT_CLOCK_DOMAIN_IDX_3	AEM_CFG_STREAM_OUTPUT_CLOCK_DOMAIN_IDX_0
#define AEM_CFG_STREAM_OUTPUT_STREAM_FLAGS_3		AEM_CFG_STREAM_OUTPUT_STREAM_FLAGS_0
#define AEM_CFG_STREAM_OUTPUT_CURRENT_FORMAT_3		AEM_CFG_STREAM_OUTPUT_CURRENT_FORMAT_0
#define AEM_CFG_STREAM_OUTPUT_NB_FORMATS_3		AEM_CFG_STREAM_OUTPUT_NB_FORMATS_0
#define AEM_CFG_STREAM_OUTPUT_BACKUP_TALKER_ENTITY_0_3	AEM_CFG_STREAM_OUTPUT_BACKUP_TALKER_ENTITY_0_0
#define AEM_CFG_STREAM_OUTPUT_BACKUP_TALKER_UNIQUE_0_3	AEM_CFG_STREAM_OUTPUT_BACKUP_TALKER_UNIQUE_0_0
#define AEM_CFG_STREAM_OUTPUT_BACKUP_TALKER_ENTITY_1_3	AEM_CFG_STREAM_OUTPUT_BACKUP_TALKER_ENTITY_1_0
#define AEM_CFG_STREAM_OUTPUT_BACKUP_TALKER_UNIQUE_1_3	AEM_CFG_STREAM_OUTPUT_BACKUP_TALKER_UNIQUE_1_0
#define AEM_CFG_STREAM_OUTPUT_BACKUP_TALKER_ENTITY_2_3	AEM_CFG_STREAM_OUTPUT_BACKUP_TALKER_ENTITY_2_0
#define AEM_CFG_STREAM_OUTPUT_BACKUP_TALKER_UNIQUE_2_3	AEM_CFG_STREAM_OUTPUT_BACKUP_TALKER_UNIQUE_2_0
#define AEM_CFG_STREAM_OUTPUT_BACKEDUP_TALKER_ENTITY_3	AEM_CFG_STREAM_OUTPUT_BACKEDUP_TALKER_ENTITY_0
#define AEM_CFG_STREAM_OUTPUT_BACKEDUP_TALKER_UNIQUE_3	AEM_CFG_STREAM_OUTPUT_BACKEDUP_TALKER_UNIQUE_0
#define AEM_CFG_STREAM_OUTPUT_AVB_ITF_INDEX_3		AEM_CFG_STREAM_OUTPUT_AVB_ITF_INDEX_0
#define AEM_CFG_STREAM_OUTPUT_BUFFER_LENGTH_3		AEM_CFG_STREAM_OUTPUT_BUFFER_LENGTH_0
#define AEM_CFG_STREAM_OUTPUT_FORMATS_3			AEM_CFG_STREAM_OUTPUT_FORMATS_0

#define AEM_CFG_STREAM_OUTPUT_NAME_4			"Stream output 4"
#define AEM_CFG_STREAM_OUTPUT_LOC_DESC_4		AEM_CFG_STREAM_OUTPUT_LOC_DESC_0
#define AEM_CFG_STREAM_OUTPUT_CLOCK_DOMAIN_IDX_4	AEM_CFG_STREAM_OUTPUT_CLOCK_DOMAIN_IDX_0
#define AEM_CFG_STREAM_OUTPUT_STREAM_FLAGS_4		AEM_CFG_STREAM_OUTPUT_STREAM_FLAGS_0
#define AEM_CFG_STREAM_OUTPUT_CURRENT_FORMAT_4		AEM_CFG_STREAM_OUTPUT_CURRENT_FORMAT_0
#define AEM_CFG_STREAM_OUTPUT_NB_FORMATS_4		AEM_CFG_STREAM_OUTPUT_NB_FORMATS_0
#define AEM_CFG_STREAM_OUTPUT_BACKUP_TALKER_ENTITY_0_4	AEM_CFG_STREAM_OUTPUT_BACKUP_TALKER_ENTITY_0_0
#define AEM_CFG_STREAM_OUTPUT_BACKUP_TALKER_UNIQUE_0_4	AEM_CFG_STREAM_OUTPUT_BACKUP_TALKER_UNIQUE_0_0
#define AEM_CFG_STREAM_OUTPUT_BACKUP_TALKER_ENTITY_1_4	AEM_CFG_STREAM_OUTPUT_BACKUP_TALKER_ENTITY_1_0
#define AEM_CFG_STREAM_OUTPUT_BACKUP_TALKER_UNIQUE_1_4	AEM_CFG_STREAM_OUTPUT_BACKUP_TALKER_UNIQUE_1_0
#define AEM_CFG_STREAM_OUTPUT_BACKUP_TALKER_ENTITY_2_4	AEM_CFG_STREAM_OUTPUT_BACKUP_TALKER_ENTITY_2_0
#define AEM_CFG_STREAM_OUTPUT_BACKUP_TALKER_UNIQUE_2_4	AEM_CFG_STREAM_OUTPUT_BACKUP_TALKER_UNIQUE_2_0
#define AEM_CFG_STREAM_OUTPUT_BACKEDUP_TALKER_ENTITY_4	AEM_CFG_STREAM_OUTPUT_BACKEDUP_TALKER_ENTITY_0
#define AEM_CFG_STREAM_OUTPUT_BACKEDUP_TALKER_UNIQUE_4	AEM_CFG_STREAM_OUTPUT_BACKEDUP_TALKER_UNIQUE_0
#define AEM_CFG_STREAM_OUTPUT_AVB_ITF_INDEX_4		AEM_CFG_STREAM_OUTPUT_AVB_ITF_INDEX_0
#define AEM_CFG_STREAM_OUTPUT_BUFFER_LENGTH_4		AEM_CFG_STREAM_OUTPUT_BUFFER_LENGTH_0
#define AEM_CFG_STREAM_OUTPUT_FORMATS_4			AEM_CFG_STREAM_OUTPUT_FORMATS_0

#define AEM_CFG_STREAM_OUTPUT_NAME_5			"Stream output 5"
#define AEM_CFG_STREAM_OUTPUT_LOC_DESC_5		AEM_CFG_STREAM_OUTPUT_LOC_DESC_0
#define AEM_CFG_STREAM_OUTPUT_CLOCK_DOMAIN_IDX_5	AEM_CFG_STREAM_OUTPUT_CLOCK_DOMAIN_IDX_0
#define AEM_CFG_STREAM_OUTPUT_STREAM_FLAGS_5		AEM_CFG_STREAM_OUTPUT_STREAM_FLAGS_0
#define AEM_CFG_STREAM_OUTPUT_CURRENT_FORMAT_5		AEM_CFG_STREAM_OUTPUT_CURRENT_FORMAT_0
#define AEM_CFG_STREAM_OUTPUT_NB_FORMATS_5		AEM_CFG_STREAM_OUTPUT_NB_FORMATS_0
#define AEM_CFG_STREAM_OUTPUT_BACKUP_TALKER_ENTITY_0_5	AEM_CFG_STREAM_OUTPUT_BACKUP_TALKER_ENTITY_0_0
#define AEM_CFG_STREAM_OUTPUT_BACKUP_TALKER_UNIQUE_0_5	AEM_CFG_STREAM_OUTPUT_BACKUP_TALKER_UNIQUE_0_0
#define AEM_CFG_STREAM_OUTPUT_BACKUP_TALKER_ENTITY_1_5	AEM_CFG_STREAM_OUTPUT_BACKUP_TALKER_ENTITY_1_0
#define AEM_CFG_STREAM_OUTPUT_BACKUP_TALKER_UNIQUE_1_5	AEM_CFG_STREAM_OUTPUT_BACKUP_TALKER_UNIQUE_1_0
#define AEM_CFG_STREAM_OUTPUT_BACKUP_TALKER_ENTITY_2_5	AEM_CFG_STREAM_OUTPUT_BACKUP_TALKER_ENTITY_2_0
#define AEM_CFG_STREAM_OUTPUT_BACKUP_TALKER_UNIQUE_2_5	AEM_CFG_STREAM_OUTPUT_BACKUP_TALKER_UNIQUE_2_0
#define AEM_CFG_STREAM_OUTPUT_BACKEDUP_TALKER_ENTITY_5	AEM_CFG_STREAM_OUTPUT_BACKEDUP_TALKER_ENTITY_0
#define AEM_CFG_STREAM_OUTPUT_BACKEDUP_TALKER_UNIQUE_5	AEM_CFG_STREAM_OUTPUT_BACKEDUP_TALKER_UNIQUE_0
#define AEM_CFG_STREAM_OUTPUT_AVB_ITF_INDEX_5		AEM_CFG_STREAM_OUTPUT_AVB_ITF_INDEX_0
#define AEM_CFG_STREAM_OUTPUT_BUFFER_LENGTH_5		AEM_CFG_STREAM_OUTPUT_BUFFER_LENGTH_0
#define AEM_CFG_STREAM_OUTPUT_FORMATS_5			AEM_CFG_STREAM_OUTPUT_FORMATS_0

#define AEM_CFG_STREAM_OUTPUT_NAME_6			"Stream output 6"
#define AEM_CFG_STREAM_OUTPUT_LOC_DESC_6		AEM_CFG_STREAM_OUTPUT_LOC_DESC_0
#define AEM_CFG_STREAM_OUTPUT_CLOCK_DOMAIN_IDX_6	AEM_CFG_STREAM_OUTPUT_CLOCK_DOMAIN_IDX_0
#define AEM_CFG_STREAM_OUTPUT_STREAM_FLAGS_6		AEM_CFG_STREAM_OUTPUT_STREAM_FLAGS_0
#define AEM_CFG_STREAM_OUTPUT_CURRENT_FORMAT_6		AEM_CFG_STREAM_OUTPUT_CURRENT_FORMAT_0
#define AEM_CFG_STREAM_OUTPUT_NB_FORMATS_6		AEM_CFG_STREAM_OUTPUT_NB_FORMATS_0
#define AEM_CFG_STREAM_OUTPUT_BACKUP_TALKER_ENTITY_0_6	AEM_CFG_STREAM_OUTPUT_BACKUP_TALKER_ENTITY_0_0
#define AEM_CFG_STREAM_OUTPUT_BACKUP_TALKER_UNIQUE_0_6	AEM_CFG_STREAM_OUTPUT_BACKUP_TALKER_UNIQUE_0_0
#define AEM_CFG_STREAM_OUTPUT_BACKUP_TALKER_ENTITY_1_6	AEM_CFG_STREAM_OUTPUT_BACKUP_TALKER_ENTITY_1_0
#define AEM_CFG_STREAM_OUTPUT_BACKUP_TALKER_UNIQUE_1_6	AEM_CFG_STREAM_OUTPUT_BACKUP_TALKER_UNIQUE_1_0
#define AEM_CFG_STREAM_OUTPUT_BACKUP_TALKER_ENTITY_2_6	AEM_CFG_STREAM_OUTPUT_BACKUP_TALKER_ENTITY_2_0
#define AEM_CFG_STREAM_OUTPUT_BACKUP_TALKER_UNIQUE_2_6	AEM_CFG_STREAM_OUTPUT_BACKUP_TALKER_UNIQUE_2_0
#define AEM_CFG_STREAM_OUTPUT_BACKEDUP_TALKER_ENTITY_6	AEM_CFG_STREAM_OUTPUT_BACKEDUP_TALKER_ENTITY_0
#define AEM_CFG_STREAM_OUTPUT_BACKEDUP_TALKER_UNIQUE_6	AEM_CFG_STREAM_OUTPUT_BACKEDUP_TALKER_UNIQUE_0
#define AEM_CFG_STREAM_OUTPUT_AVB_ITF_INDEX_6		AEM_CFG_STREAM_OUTPUT_AVB_ITF_INDEX_0
#define AEM_CFG_STREAM_OUTPUT_BUFFER_LENGTH_6		AEM_CFG_STREAM_OUTPUT_BUFFER_LENGTH_0
#define AEM_CFG_STREAM_OUTPUT_FORMATS_6			AEM_CFG_STREAM_OUTPUT_FORMATS_0

#define AEM_CFG_STREAM_OUTPUT_NAME_7			"Stream output 7"
#define AEM_CFG_STREAM_OUTPUT_LOC_DESC_7		AEM_CFG_STREAM_OUTPUT_LOC_DESC_0
#define AEM_CFG_STREAM_OUTPUT_CLOCK_DOMAIN_IDX_7	AEM_CFG_STREAM_OUTPUT_CLOCK_DOMAIN_IDX_0
#define AEM_CFG_STREAM_OUTPUT_STREAM_FLAGS_7		AEM_CFG_STREAM_OUTPUT_STREAM_FLAGS_0
#define AEM_CFG_STREAM_OUTPUT_CURRENT_FORMAT_7		AEM_CFG_STREAM_OUTPUT_CURRENT_FORMAT_0
#define AEM_CFG_STREAM_OUTPUT_NB_FORMATS_7		AEM_CFG_STREAM_OUTPUT_NB_FORMATS_0
#define AEM_CFG_STREAM_OUTPUT_BACKUP_TALKER_ENTITY_0_7	AEM_CFG_STREAM_OUTPUT_BACKUP_TALKER_ENTITY_0_0
#define AEM_CFG_STREAM_OUTPUT_BACKUP_TALKER_UNIQUE_0_7	AEM_CFG_STREAM_OUTPUT_BACKUP_TALKER_UNIQUE_0_0
#define AEM_CFG_STREAM_OUTPUT_BACKUP_TALKER_ENTITY_1_7	AEM_CFG_STREAM_OUTPUT_BACKUP_TALKER_ENTITY_1_0
#define AEM_CFG_STREAM_OUTPUT_BACKUP_TALKER_UNIQUE_1_7	AEM_CFG_STREAM_OUTPUT_BACKUP_TALKER_UNIQUE_1_0
#define AEM_CFG_STREAM_OUTPUT_BACKUP_TALKER_ENTITY_2_7	AEM_CFG_STREAM_OUTPUT_BACKUP_TALKER_ENTITY_2_0
#define AEM_CFG_STREAM_OUTPUT_BACKUP_TALKER_UNIQUE_2_7	AEM_CFG_STREAM_OUTPUT_BACKUP_TALKER_UNIQUE_2_0
#define AEM_CFG_STREAM_OUTPUT_BACKEDUP_TALKER_ENTITY_7	AEM_CFG_STREAM_OUTPUT_BACKEDUP_TALKER_ENTITY_0
#define AEM_CFG_STREAM_OUTPUT_BACKEDUP_TALKER_UNIQUE_7	AEM_CFG_STREAM_OUTPUT_BACKEDUP_TALKER_UNIQUE_0
#define AEM_CFG_STREAM_OUTPUT_AVB_ITF_INDEX_7		AEM_CFG_STREAM_OUTPUT_AVB_ITF_INDEX_0
#define AEM_CFG_STREAM_OUTPUT_BUFFER_LENGTH_7		AEM_CFG_STREAM_OUTPUT_BUFFER_LENGTH_0
#define AEM_CFG_STREAM_OUTPUT_FORMATS_7			AEM_CFG_STREAM_OUTPUT_FORMATS_0

#define AEM_CFG_STREAM_OUTPUT_DESCRIPTORS {	\
						AEM_CFG_STREAM_OUTPUT_DESCRIPTOR(0), AEM_CFG_STREAM_OUTPUT_DESCRIPTOR(1), AEM_CFG_STREAM_OUTPUT_DESCRIPTOR(2), AEM_CFG_STREAM_OUTPUT_DESCRIPTOR(3),	\
						AEM_CFG_STREAM_OUTPUT_DESCRIPTOR(4), AEM_CFG_STREAM_OUTPUT_DESCRIPTOR(5), AEM_CFG_STREAM_OUTPUT_DESCRIPTOR(6), AEM_CFG_STREAM_OUTPUT_DESCRIPTOR(7)	\
					}


/* Jack input config */
#define AEM_CFG_JACK_INPUT_NAME_0		"Jack input0"
#define AEM_CFG_JACK_INPUT_LOC_DESC_0		7
#define AEM_CFG_JACK_INPUT_FLAGS_0		0
#define AEM_CFG_JACK_INPUT_TYPE_0		AEM_JACK_TYPE_UNBALANCED_ANALOG
#define AEM_CFG_JACK_INPUT_NUM_CTRL_0		0
#define AEM_CFG_JACK_INPUT_BASE_CTRL_0		0

#define AEM_CFG_JACK_INPUT_NAME_1		"Jack input1"
#define AEM_CFG_JACK_INPUT_LOC_DESC_1		7
#define AEM_CFG_JACK_INPUT_FLAGS_1		0
#define AEM_CFG_JACK_INPUT_TYPE_1		AEM_JACK_TYPE_UNBALANCED_ANALOG
#define AEM_CFG_JACK_INPUT_NUM_CTRL_1		0
#define AEM_CFG_JACK_INPUT_BASE_CTRL_1		0

#define AEM_CFG_JACK_INPUT_NAME_2		"Jack input2"
#define AEM_CFG_JACK_INPUT_LOC_DESC_2		7
#define AEM_CFG_JACK_INPUT_FLAGS_2		0
#define AEM_CFG_JACK_INPUT_TYPE_2		AEM_JACK_TYPE_UNBALANCED_ANALOG
#define AEM_CFG_JACK_INPUT_NUM_CTRL_2		0
#define AEM_CFG_JACK_INPUT_BASE_CTRL_2		0

#define AEM_CFG_JACK_INPUT_NAME_3		"Jack input3"
#define AEM_CFG_JACK_INPUT_LOC_DESC_3		7
#define AEM_CFG_JACK_INPUT_FLAGS_3		0
#define AEM_CFG_JACK_INPUT_TYPE_3		AEM_JACK_TYPE_UNBALANCED_ANALOG
#define AEM_CFG_JACK_INPUT_NUM_CTRL_3		0
#define AEM_CFG_JACK_INPUT_BASE_CTRL_3		0

#define AEM_CFG_JACK_INPUT_NAME_4		"Jack input4"
#define AEM_CFG_JACK_INPUT_LOC_DESC_4		7
#define AEM_CFG_JACK_INPUT_FLAGS_4		0
#define AEM_CFG_JACK_INPUT_TYPE_4		AEM_JACK_TYPE_UNBALANCED_ANALOG
#define AEM_CFG_JACK_INPUT_NUM_CTRL_4		0
#define AEM_CFG_JACK_INPUT_BASE_CTRL_4		0

#define AEM_CFG_JACK_INPUT_NAME_5		"Jack input5"
#define AEM_CFG_JACK_INPUT_LOC_DESC_5		7
#define AEM_CFG_JACK_INPUT_FLAGS_5		0
#define AEM_CFG_JACK_INPUT_TYPE_5		AEM_JACK_TYPE_UNBALANCED_ANALOG
#define AEM_CFG_JACK_INPUT_NUM_CTRL_5		0
#define AEM_CFG_JACK_INPUT_BASE_CTRL_5		0

#define AEM_CFG_JACK_INPUT_NAME_6		"Jack input6"
#define AEM_CFG_JACK_INPUT_LOC_DESC_6		7
#define AEM_CFG_JACK_INPUT_FLAGS_6		0
#define AEM_CFG_JACK_INPUT_TYPE_6		AEM_JACK_TYPE_UNBALANCED_ANALOG
#define AEM_CFG_JACK_INPUT_NUM_CTRL_6		0
#define AEM_CFG_JACK_INPUT_BASE_CTRL_6		0

#define AEM_CFG_JACK_INPUT_NAME_7		"Jack input7"
#define AEM_CFG_JACK_INPUT_LOC_DESC_7		7
#define AEM_CFG_JACK_INPUT_FLAGS_7		0
#define AEM_CFG_JACK_INPUT_TYPE_7		AEM_JACK_TYPE_UNBALANCED_ANALOG
#define AEM_CFG_JACK_INPUT_NUM_CTRL_7		0
#define AEM_CFG_JACK_INPUT_BASE_CTRL_7		0

#define AEM_CFG_JACK_INPUT_DESCRIPTORS {	\
						AEM_CFG_JACK_INPUT_DESCRIPTOR(0), AEM_CFG_JACK_INPUT_DESCRIPTOR(1), AEM_CFG_JACK_INPUT_DESCRIPTOR(2), AEM_CFG_JACK_INPUT_DESCRIPTOR(3),	\
						AEM_CFG_JACK_INPUT_DESCRIPTOR(4), AEM_CFG_JACK_INPUT_DESCRIPTOR(5), AEM_CFG_JACK_INPUT_DESCRIPTOR(6), AEM_CFG_JACK_INPUT_DESCRIPTOR(7)	\
					}

/* Jack output config */
#define AEM_CFG_JACK_OUTPUT_NAME_0		"Jack output0"
#define AEM_CFG_JACK_OUTPUT_LOC_DESC_0		7
#define AEM_CFG_JACK_OUTPUT_FLAGS_0		0
#define AEM_CFG_JACK_OUTPUT_TYPE_0		AEM_JACK_TYPE_UNBALANCED_ANALOG
#define AEM_CFG_JACK_OUTPUT_NUM_CTRL_0		0
#define AEM_CFG_JACK_OUTPUT_BASE_CTRL_0		0

#define AEM_CFG_JACK_OUTPUT_NAME_1		"Jack output1"
#define AEM_CFG_JACK_OUTPUT_LOC_DESC_1		AEM_CFG_JACK_OUTPUT_LOC_DESC_0
#define AEM_CFG_JACK_OUTPUT_FLAGS_1		AEM_CFG_JACK_OUTPUT_FLAGS_0
#define AEM_CFG_JACK_OUTPUT_TYPE_1		AEM_CFG_JACK_OUTPUT_TYPE_0
#define AEM_CFG_JACK_OUTPUT_NUM_CTRL_1		AEM_CFG_JACK_OUTPUT_NUM_CTRL_0
#define AEM_CFG_JACK_OUTPUT_BASE_CTRL_1		AEM_CFG_JACK_OUTPUT_BASE_CTRL_0

#define AEM_CFG_JACK_OUTPUT_NAME_2		"Jack output2"
#define AEM_CFG_JACK_OUTPUT_LOC_DESC_2		AEM_CFG_JACK_OUTPUT_LOC_DESC_0
#define AEM_CFG_JACK_OUTPUT_FLAGS_2		AEM_CFG_JACK_OUTPUT_FLAGS_0
#define AEM_CFG_JACK_OUTPUT_TYPE_2		AEM_CFG_JACK_OUTPUT_TYPE_0
#define AEM_CFG_JACK_OUTPUT_NUM_CTRL_2		AEM_CFG_JACK_OUTPUT_NUM_CTRL_0
#define AEM_CFG_JACK_OUTPUT_BASE_CTRL_2		AEM_CFG_JACK_OUTPUT_BASE_CTRL_0

#define AEM_CFG_JACK_OUTPUT_NAME_3		"Jack output3"
#define AEM_CFG_JACK_OUTPUT_LOC_DESC_3		AEM_CFG_JACK_OUTPUT_LOC_DESC_0
#define AEM_CFG_JACK_OUTPUT_FLAGS_3		AEM_CFG_JACK_OUTPUT_FLAGS_0
#define AEM_CFG_JACK_OUTPUT_TYPE_3		AEM_CFG_JACK_OUTPUT_TYPE_0
#define AEM_CFG_JACK_OUTPUT_NUM_CTRL_3		AEM_CFG_JACK_OUTPUT_NUM_CTRL_0
#define AEM_CFG_JACK_OUTPUT_BASE_CTRL_3		AEM_CFG_JACK_OUTPUT_BASE_CTRL_0

#define AEM_CFG_JACK_OUTPUT_NAME_4		"Jack output4"
#define AEM_CFG_JACK_OUTPUT_LOC_DESC_4		AEM_CFG_JACK_OUTPUT_LOC_DESC_0
#define AEM_CFG_JACK_OUTPUT_FLAGS_4		AEM_CFG_JACK_OUTPUT_FLAGS_0
#define AEM_CFG_JACK_OUTPUT_TYPE_4		AEM_CFG_JACK_OUTPUT_TYPE_0
#define AEM_CFG_JACK_OUTPUT_NUM_CTRL_4		AEM_CFG_JACK_OUTPUT_NUM_CTRL_0
#define AEM_CFG_JACK_OUTPUT_BASE_CTRL_4		AEM_CFG_JACK_OUTPUT_BASE_CTRL_0

#define AEM_CFG_JACK_OUTPUT_NAME_5		"Jack output5"
#define AEM_CFG_JACK_OUTPUT_LOC_DESC_5		AEM_CFG_JACK_OUTPUT_LOC_DESC_0
#define AEM_CFG_JACK_OUTPUT_FLAGS_5		AEM_CFG_JACK_OUTPUT_FLAGS_0
#define AEM_CFG_JACK_OUTPUT_TYPE_5		AEM_CFG_JACK_OUTPUT_TYPE_0
#define AEM_CFG_JACK_OUTPUT_NUM_CTRL_5		AEM_CFG_JACK_OUTPUT_NUM_CTRL_0
#define AEM_CFG_JACK_OUTPUT_BASE_CTRL_5		AEM_CFG_JACK_OUTPUT_BASE_CTRL_0

#define AEM_CFG_JACK_OUTPUT_NAME_6		"Jack output6"
#define AEM_CFG_JACK_OUTPUT_LOC_DESC_6		AEM_CFG_JACK_OUTPUT_LOC_DESC_0
#define AEM_CFG_JACK_OUTPUT_FLAGS_6		AEM_CFG_JACK_OUTPUT_FLAGS_0
#define AEM_CFG_JACK_OUTPUT_TYPE_6		AEM_CFG_JACK_OUTPUT_TYPE_0
#define AEM_CFG_JACK_OUTPUT_NUM_CTRL_6		AEM_CFG_JACK_OUTPUT_NUM_CTRL_0
#define AEM_CFG_JACK_OUTPUT_BASE_CTRL_6		AEM_CFG_JACK_OUTPUT_BASE_CTRL_0

#define AEM_CFG_JACK_OUTPUT_NAME_7		"Jack output7"
#define AEM_CFG_JACK_OUTPUT_LOC_DESC_7		AEM_CFG_JACK_OUTPUT_LOC_DESC_0
#define AEM_CFG_JACK_OUTPUT_FLAGS_7		AEM_CFG_JACK_OUTPUT_FLAGS_0
#define AEM_CFG_JACK_OUTPUT_TYPE_7		AEM_CFG_JACK_OUTPUT_TYPE_0
#define AEM_CFG_JACK_OUTPUT_NUM_CTRL_7		AEM_CFG_JACK_OUTPUT_NUM_CTRL_0
#define AEM_CFG_JACK_OUTPUT_BASE_CTRL_7		AEM_CFG_JACK_OUTPUT_BASE_CTRL_0

#define AEM_CFG_JACK_OUTPUT_DESCRIPTORS {	\
						AEM_CFG_JACK_OUTPUT_DESCRIPTOR(0), AEM_CFG_JACK_OUTPUT_DESCRIPTOR(1), AEM_CFG_JACK_OUTPUT_DESCRIPTOR(2), AEM_CFG_JACK_OUTPUT_DESCRIPTOR(3), \
						AEM_CFG_JACK_OUTPUT_DESCRIPTOR(4), AEM_CFG_JACK_OUTPUT_DESCRIPTOR(5), AEM_CFG_JACK_OUTPUT_DESCRIPTOR(6), AEM_CFG_JACK_OUTPUT_DESCRIPTOR(7), \
					}


/* AVB interface config */
#define AEM_CFG_AVB_ITF_NAME_0			"AVB interface"
#define AEM_CFG_AVB_ITF_LOC_DESC_0		7
#define AEM_CFG_AVB_ITF_ITF_FLAGS_0		AEM_AVB_FLAGS_GPTP_SUPPORTED
#define AEM_CFG_AVB_ITF_CLOCK_ID_0		0
#define AEM_CFG_AVB_ITF_PRIO1_0			0xFF
#define AEM_CFG_AVB_ITF_CLOCK_CLASS_0		0xFF
#define AEM_CFG_AVB_ITF_OFF_SCALED_VAR_0	0
#define AEM_CFG_AVB_ITF_CLOCK_ACCURACY_0	0xFF
#define AEM_CFG_AVB_ITF_PRIO2_0			0xFF
#define AEM_CFG_AVB_ITF_DOMAIN_NB_0		0
#define AEM_CFG_AVB_ITF_LOG_SYN_INTER_0		0
#define AEM_CFG_AVB_ITF_LOG_ANN_INTER_0		0
#define AEM_CFG_AVB_ITF_POG_PDEL_INTER_0	0
#define AEM_CFG_AVB_ITF_PORT_NB_0		0


#define AEM_CFG_AVB_ITF_DESCRIPTORS {AEM_CFG_AVB_ITF_DESCRIPTOR(0)}


/* Clock source config */
#define AEM_CFG_CLK_SOURCE_NAME_0		"Clock source"
#define AEM_CFG_CLK_SOURCE_LOC_DESC_0		7
#define AEM_CFG_CLK_SOURCE_FLAGS_0		AEM_CLOCK_SOURCE_FLAGS_LOCAL_ID
#define AEM_CFG_CLK_SOURCE_TYPE_0		AEM_CLOCK_SOURCE_TYPE_INPUT_STREAM
#define AEM_CFG_CLK_SOURCE_ID_0			0
#define AEM_CFG_CLK_SOURCE_LOC_TYPE_0		AEM_DESC_TYPE_STREAM_INPUT
#define AEM_CFG_CLK_SOURCE_LOC_INDEX_0		0


#define AEM_CFG_CLK_SOURCE_DESCRIPTORS {AEM_CFG_CLK_SOURCE_DESCRIPTOR(0)}

/* Locale config */
#define AEM_CFG_LOCALE_IDENTIFIER_0		"en"
#define AEM_CFG_LOCALE_NB_STRINGS_0		1
#define AEM_CFG_LOCALE_BASE_STRINGS_0		0


#define AEM_CFG_LOCALE_DESCRIPTORS {AEM_CFG_LOCALE_DESCRIPTOR(0)}

/* Strings config */
#define AEM_CFG_STRINGS_0_0			"NXP AVB"
#define AEM_CFG_STRINGS_1_0			{}
#define AEM_CFG_STRINGS_2_0			{}
#define AEM_CFG_STRINGS_3_0			{}
#define AEM_CFG_STRINGS_4_0			{}
#define AEM_CFG_STRINGS_5_0			{}
#define AEM_CFG_STRINGS_6_0			{}

#define AEM_CFG_STRINGS_DESCRIPTORS {AEM_CFG_STRINGS_DESCRIPTOR(0)}

/* Clock domain config */
#define AEM_CFG_CLK_DOMAIN_NAME_0		"Clock domain"
#define AEM_CFG_CLK_DOMAIN_LOC_DESC_0		7
#define AEM_CFG_CLK_DOMAIN_SOURCE_IDX_0		0
#define AEM_CFG_CLK_DOMAIN_SOURCES_COUNT_0	1
#define AEM_CFG_CLK_DOMAIN_SOURCES_0		{htons(0)}

#define AEM_CFG_CLK_DOMAIN_DESCRIPTORS {AEM_CFG_CLK_DOMAIN_DESCRIPTOR(0)}

/* Stream port input config */
#define AEM_CFG_STREAM_PORT_IN_CLK_DOM_IDX_0		0
#define AEM_CFG_STREAM_PORT_IN_PORT_FLAGS_0		0
#define AEM_CFG_STREAM_PORT_IN_NB_CONTROLS_0		0
#define AEM_CFG_STREAM_PORT_IN_BASE_CONTROL_0		0
#define AEM_CFG_STREAM_PORT_IN_NB_CLUSTERS_0		8
#define AEM_CFG_STREAM_PORT_IN_BASE_CLUSTER_0		0
#define AEM_CFG_STREAM_PORT_IN_NB_MAPS_0		1
#define AEM_CFG_STREAM_PORT_IN_BASE_MAP_0		0


#define AEM_CFG_STREAM_PORT_IN_DESCRIPTORS {AEM_CFG_STREAM_PORT_IN_DESCRIPTOR(0)}


/* Stream port output config */
#define AEM_CFG_STREAM_PORT_OUT_CLK_DOM_IDX_0		0
#define AEM_CFG_STREAM_PORT_OUT_PORT_FLAGS_0		0
#define AEM_CFG_STREAM_PORT_OUT_NB_CONTROLS_0		0
#define AEM_CFG_STREAM_PORT_OUT_BASE_CONTROL_0		0
#define AEM_CFG_STREAM_PORT_OUT_NB_CLUSTERS_0		8
#define AEM_CFG_STREAM_PORT_OUT_BASE_CLUSTER_0		8
#define AEM_CFG_STREAM_PORT_OUT_NB_MAPS_0		1
#define AEM_CFG_STREAM_PORT_OUT_BASE_MAP_0		0

#define AEM_CFG_STREAM_PORT_OUT_DESCRIPTORS {AEM_CFG_STREAM_PORT_OUT_DESCRIPTOR(0)}


/* Audio cluster config */
#define AEM_CFG_AUDIO_CLUSTER_NAME_0			"Audio cluster 0"
#define AEM_CFG_AUDIO_CLUSTER_LOC_DESC_0		7
#define AEM_CFG_AUDIO_CLUSTER_SIGNAL_TYPE_0		AEM_DESC_TYPE_INVALID
#define AEM_CFG_AUDIO_CLUSTER_SIGNAL_IDX_0		0
#define AEM_CFG_AUDIO_CLUSTER_SIGNAL_OUTPUT_0		0
#define AEM_CFG_AUDIO_CLUSTER_PATH_LAT_0		1000000
#define AEM_CFG_AUDIO_CLUSTER_BLOCK_LAT_0		0
#define AEM_CFG_AUDIO_CLUSTER_CHAN_COUNT_0		2
#define AEM_CFG_AUDIO_CLUSTER_FORMAT_0			AEM_AUDIO_CLUSTER_FORMAT_MBLA

#define AEM_CFG_AUDIO_CLUSTER_NAME_1			"Audio cluster 1"
#define AEM_CFG_AUDIO_CLUSTER_LOC_DESC_1		AEM_CFG_AUDIO_CLUSTER_LOC_DESC_0
#define AEM_CFG_AUDIO_CLUSTER_SIGNAL_TYPE_1		AEM_CFG_AUDIO_CLUSTER_SIGNAL_TYPE_0
#define AEM_CFG_AUDIO_CLUSTER_SIGNAL_IDX_1		AEM_CFG_AUDIO_CLUSTER_SIGNAL_IDX_0
#define AEM_CFG_AUDIO_CLUSTER_SIGNAL_OUTPUT_1		AEM_CFG_AUDIO_CLUSTER_SIGNAL_OUTPUT_0
#define AEM_CFG_AUDIO_CLUSTER_PATH_LAT_1		AEM_CFG_AUDIO_CLUSTER_PATH_LAT_0
#define AEM_CFG_AUDIO_CLUSTER_BLOCK_LAT_1		AEM_CFG_AUDIO_CLUSTER_BLOCK_LAT_0
#define AEM_CFG_AUDIO_CLUSTER_CHAN_COUNT_1		AEM_CFG_AUDIO_CLUSTER_CHAN_COUNT_0
#define AEM_CFG_AUDIO_CLUSTER_FORMAT_1			AEM_CFG_AUDIO_CLUSTER_FORMAT_0

#define AEM_CFG_AUDIO_CLUSTER_NAME_2			"Audio cluster 2"
#define AEM_CFG_AUDIO_CLUSTER_LOC_DESC_2		AEM_CFG_AUDIO_CLUSTER_LOC_DESC_0
#define AEM_CFG_AUDIO_CLUSTER_SIGNAL_TYPE_2		AEM_CFG_AUDIO_CLUSTER_SIGNAL_TYPE_0
#define AEM_CFG_AUDIO_CLUSTER_SIGNAL_IDX_2		AEM_CFG_AUDIO_CLUSTER_SIGNAL_IDX_0
#define AEM_CFG_AUDIO_CLUSTER_SIGNAL_OUTPUT_2		AEM_CFG_AUDIO_CLUSTER_SIGNAL_OUTPUT_0
#define AEM_CFG_AUDIO_CLUSTER_PATH_LAT_2		AEM_CFG_AUDIO_CLUSTER_PATH_LAT_0
#define AEM_CFG_AUDIO_CLUSTER_BLOCK_LAT_2		AEM_CFG_AUDIO_CLUSTER_BLOCK_LAT_0
#define AEM_CFG_AUDIO_CLUSTER_CHAN_COUNT_2		AEM_CFG_AUDIO_CLUSTER_CHAN_COUNT_0
#define AEM_CFG_AUDIO_CLUSTER_FORMAT_2			AEM_CFG_AUDIO_CLUSTER_FORMAT_0

#define AEM_CFG_AUDIO_CLUSTER_NAME_3			"Audio cluster 3"
#define AEM_CFG_AUDIO_CLUSTER_LOC_DESC_3		AEM_CFG_AUDIO_CLUSTER_LOC_DESC_0
#define AEM_CFG_AUDIO_CLUSTER_SIGNAL_TYPE_3		AEM_CFG_AUDIO_CLUSTER_SIGNAL_TYPE_0
#define AEM_CFG_AUDIO_CLUSTER_SIGNAL_IDX_3		AEM_CFG_AUDIO_CLUSTER_SIGNAL_IDX_0
#define AEM_CFG_AUDIO_CLUSTER_SIGNAL_OUTPUT_3		AEM_CFG_AUDIO_CLUSTER_SIGNAL_OUTPUT_0
#define AEM_CFG_AUDIO_CLUSTER_PATH_LAT_3		AEM_CFG_AUDIO_CLUSTER_PATH_LAT_0
#define AEM_CFG_AUDIO_CLUSTER_BLOCK_LAT_3		AEM_CFG_AUDIO_CLUSTER_BLOCK_LAT_0
#define AEM_CFG_AUDIO_CLUSTER_CHAN_COUNT_3		AEM_CFG_AUDIO_CLUSTER_CHAN_COUNT_0
#define AEM_CFG_AUDIO_CLUSTER_FORMAT_3			AEM_CFG_AUDIO_CLUSTER_FORMAT_0

#define AEM_CFG_AUDIO_CLUSTER_NAME_4			"Audio cluster 4"
#define AEM_CFG_AUDIO_CLUSTER_LOC_DESC_4		AEM_CFG_AUDIO_CLUSTER_LOC_DESC_0
#define AEM_CFG_AUDIO_CLUSTER_SIGNAL_TYPE_4		AEM_CFG_AUDIO_CLUSTER_SIGNAL_TYPE_0
#define AEM_CFG_AUDIO_CLUSTER_SIGNAL_IDX_4		AEM_CFG_AUDIO_CLUSTER_SIGNAL_IDX_0
#define AEM_CFG_AUDIO_CLUSTER_SIGNAL_OUTPUT_4		AEM_CFG_AUDIO_CLUSTER_SIGNAL_OUTPUT_0
#define AEM_CFG_AUDIO_CLUSTER_PATH_LAT_4		AEM_CFG_AUDIO_CLUSTER_PATH_LAT_0
#define AEM_CFG_AUDIO_CLUSTER_BLOCK_LAT_4		AEM_CFG_AUDIO_CLUSTER_BLOCK_LAT_0
#define AEM_CFG_AUDIO_CLUSTER_CHAN_COUNT_4		AEM_CFG_AUDIO_CLUSTER_CHAN_COUNT_0
#define AEM_CFG_AUDIO_CLUSTER_FORMAT_4			AEM_AUDIO_CLUSTER_FORMAT_MBLA

#define AEM_CFG_AUDIO_CLUSTER_NAME_5			"Audio cluster 5"
#define AEM_CFG_AUDIO_CLUSTER_LOC_DESC_5		AEM_CFG_AUDIO_CLUSTER_LOC_DESC_0
#define AEM_CFG_AUDIO_CLUSTER_SIGNAL_TYPE_5		AEM_CFG_AUDIO_CLUSTER_SIGNAL_TYPE_0
#define AEM_CFG_AUDIO_CLUSTER_SIGNAL_IDX_5		AEM_CFG_AUDIO_CLUSTER_SIGNAL_IDX_0
#define AEM_CFG_AUDIO_CLUSTER_SIGNAL_OUTPUT_5		AEM_CFG_AUDIO_CLUSTER_SIGNAL_OUTPUT_0
#define AEM_CFG_AUDIO_CLUSTER_PATH_LAT_5		AEM_CFG_AUDIO_CLUSTER_PATH_LAT_0
#define AEM_CFG_AUDIO_CLUSTER_BLOCK_LAT_5		AEM_CFG_AUDIO_CLUSTER_BLOCK_LAT_0
#define AEM_CFG_AUDIO_CLUSTER_CHAN_COUNT_5		AEM_CFG_AUDIO_CLUSTER_CHAN_COUNT_0
#define AEM_CFG_AUDIO_CLUSTER_FORMAT_5			AEM_CFG_AUDIO_CLUSTER_FORMAT_0

#define AEM_CFG_AUDIO_CLUSTER_NAME_6			"Audio cluster 6"
#define AEM_CFG_AUDIO_CLUSTER_LOC_DESC_6		AEM_CFG_AUDIO_CLUSTER_LOC_DESC_0
#define AEM_CFG_AUDIO_CLUSTER_SIGNAL_TYPE_6		AEM_CFG_AUDIO_CLUSTER_SIGNAL_TYPE_0
#define AEM_CFG_AUDIO_CLUSTER_SIGNAL_IDX_6		AEM_CFG_AUDIO_CLUSTER_SIGNAL_IDX_0
#define AEM_CFG_AUDIO_CLUSTER_SIGNAL_OUTPUT_6		AEM_CFG_AUDIO_CLUSTER_SIGNAL_OUTPUT_0
#define AEM_CFG_AUDIO_CLUSTER_PATH_LAT_6		AEM_CFG_AUDIO_CLUSTER_PATH_LAT_0
#define AEM_CFG_AUDIO_CLUSTER_BLOCK_LAT_6		AEM_CFG_AUDIO_CLUSTER_BLOCK_LAT_0
#define AEM_CFG_AUDIO_CLUSTER_CHAN_COUNT_6		AEM_CFG_AUDIO_CLUSTER_CHAN_COUNT_0
#define AEM_CFG_AUDIO_CLUSTER_FORMAT_6			AEM_CFG_AUDIO_CLUSTER_FORMAT_0

#define AEM_CFG_AUDIO_CLUSTER_NAME_7			"Audio cluster 7"
#define AEM_CFG_AUDIO_CLUSTER_LOC_DESC_7		AEM_CFG_AUDIO_CLUSTER_LOC_DESC_0
#define AEM_CFG_AUDIO_CLUSTER_SIGNAL_TYPE_7		AEM_CFG_AUDIO_CLUSTER_SIGNAL_TYPE_0
#define AEM_CFG_AUDIO_CLUSTER_SIGNAL_IDX_7		AEM_CFG_AUDIO_CLUSTER_SIGNAL_IDX_0
#define AEM_CFG_AUDIO_CLUSTER_SIGNAL_OUTPUT_7		AEM_CFG_AUDIO_CLUSTER_SIGNAL_OUTPUT_0
#define AEM_CFG_AUDIO_CLUSTER_PATH_LAT_7		AEM_CFG_AUDIO_CLUSTER_PATH_LAT_0
#define AEM_CFG_AUDIO_CLUSTER_BLOCK_LAT_7		AEM_CFG_AUDIO_CLUSTER_BLOCK_LAT_0
#define AEM_CFG_AUDIO_CLUSTER_CHAN_COUNT_7		AEM_CFG_AUDIO_CLUSTER_CHAN_COUNT_0
#define AEM_CFG_AUDIO_CLUSTER_FORMAT_7			AEM_CFG_AUDIO_CLUSTER_FORMAT_0

#define AEM_CFG_AUDIO_CLUSTER_NAME_8			"Audio cluster 8"
#define AEM_CFG_AUDIO_CLUSTER_LOC_DESC_8		7
#define AEM_CFG_AUDIO_CLUSTER_SIGNAL_TYPE_8		AEM_DESC_TYPE_EXTERNAL_PORT_INPUT
#define AEM_CFG_AUDIO_CLUSTER_SIGNAL_IDX_8		0
#define AEM_CFG_AUDIO_CLUSTER_SIGNAL_OUTPUT_8		0
#define AEM_CFG_AUDIO_CLUSTER_PATH_LAT_8		0
#define AEM_CFG_AUDIO_CLUSTER_BLOCK_LAT_8		0
#define AEM_CFG_AUDIO_CLUSTER_CHAN_COUNT_8		2
#define AEM_CFG_AUDIO_CLUSTER_FORMAT_8			AEM_AUDIO_CLUSTER_FORMAT_MBLA

#define AEM_CFG_AUDIO_CLUSTER_NAME_9			"Audio cluster 9"
#define AEM_CFG_AUDIO_CLUSTER_LOC_DESC_9		7
#define AEM_CFG_AUDIO_CLUSTER_SIGNAL_TYPE_9		AEM_DESC_TYPE_EXTERNAL_PORT_INPUT
#define AEM_CFG_AUDIO_CLUSTER_SIGNAL_IDX_9		1
#define AEM_CFG_AUDIO_CLUSTER_SIGNAL_OUTPUT_9		0
#define AEM_CFG_AUDIO_CLUSTER_PATH_LAT_9		0
#define AEM_CFG_AUDIO_CLUSTER_BLOCK_LAT_9		0
#define AEM_CFG_AUDIO_CLUSTER_CHAN_COUNT_9		2
#define AEM_CFG_AUDIO_CLUSTER_FORMAT_9			AEM_AUDIO_CLUSTER_FORMAT_MBLA

#define AEM_CFG_AUDIO_CLUSTER_NAME_10			"Audio cluster 10"
#define AEM_CFG_AUDIO_CLUSTER_LOC_DESC_10		7
#define AEM_CFG_AUDIO_CLUSTER_SIGNAL_TYPE_10		AEM_DESC_TYPE_EXTERNAL_PORT_INPUT
#define AEM_CFG_AUDIO_CLUSTER_SIGNAL_IDX_10		2
#define AEM_CFG_AUDIO_CLUSTER_SIGNAL_OUTPUT_10		0
#define AEM_CFG_AUDIO_CLUSTER_PATH_LAT_10		0
#define AEM_CFG_AUDIO_CLUSTER_BLOCK_LAT_10		0
#define AEM_CFG_AUDIO_CLUSTER_CHAN_COUNT_10		2
#define AEM_CFG_AUDIO_CLUSTER_FORMAT_10			AEM_AUDIO_CLUSTER_FORMAT_MBLA

#define AEM_CFG_AUDIO_CLUSTER_NAME_11			"Audio cluster 11"
#define AEM_CFG_AUDIO_CLUSTER_LOC_DESC_11		7
#define AEM_CFG_AUDIO_CLUSTER_SIGNAL_TYPE_11		AEM_DESC_TYPE_EXTERNAL_PORT_INPUT
#define AEM_CFG_AUDIO_CLUSTER_SIGNAL_IDX_11		3
#define AEM_CFG_AUDIO_CLUSTER_SIGNAL_OUTPUT_11		0
#define AEM_CFG_AUDIO_CLUSTER_PATH_LAT_11		0
#define AEM_CFG_AUDIO_CLUSTER_BLOCK_LAT_11		0
#define AEM_CFG_AUDIO_CLUSTER_CHAN_COUNT_11		2
#define AEM_CFG_AUDIO_CLUSTER_FORMAT_11			AEM_AUDIO_CLUSTER_FORMAT_MBLA

#define AEM_CFG_AUDIO_CLUSTER_NAME_12			"Audio cluster 12"
#define AEM_CFG_AUDIO_CLUSTER_LOC_DESC_12		7
#define AEM_CFG_AUDIO_CLUSTER_SIGNAL_TYPE_12		AEM_DESC_TYPE_EXTERNAL_PORT_INPUT
#define AEM_CFG_AUDIO_CLUSTER_SIGNAL_IDX_12		4
#define AEM_CFG_AUDIO_CLUSTER_SIGNAL_OUTPUT_12		0
#define AEM_CFG_AUDIO_CLUSTER_PATH_LAT_12		0
#define AEM_CFG_AUDIO_CLUSTER_BLOCK_LAT_12		0
#define AEM_CFG_AUDIO_CLUSTER_CHAN_COUNT_12		2
#define AEM_CFG_AUDIO_CLUSTER_FORMAT_12			AEM_AUDIO_CLUSTER_FORMAT_MBLA

#define AEM_CFG_AUDIO_CLUSTER_NAME_13			"Audio cluster 13"
#define AEM_CFG_AUDIO_CLUSTER_LOC_DESC_13		7
#define AEM_CFG_AUDIO_CLUSTER_SIGNAL_TYPE_13		AEM_DESC_TYPE_EXTERNAL_PORT_INPUT
#define AEM_CFG_AUDIO_CLUSTER_SIGNAL_IDX_13		5
#define AEM_CFG_AUDIO_CLUSTER_SIGNAL_OUTPUT_13		0
#define AEM_CFG_AUDIO_CLUSTER_PATH_LAT_13		0
#define AEM_CFG_AUDIO_CLUSTER_BLOCK_LAT_13		0
#define AEM_CFG_AUDIO_CLUSTER_CHAN_COUNT_13		2
#define AEM_CFG_AUDIO_CLUSTER_FORMAT_13			AEM_AUDIO_CLUSTER_FORMAT_MBLA

#define AEM_CFG_AUDIO_CLUSTER_NAME_14			"Audio cluster 14"
#define AEM_CFG_AUDIO_CLUSTER_LOC_DESC_14		7
#define AEM_CFG_AUDIO_CLUSTER_SIGNAL_TYPE_14		AEM_DESC_TYPE_EXTERNAL_PORT_INPUT
#define AEM_CFG_AUDIO_CLUSTER_SIGNAL_IDX_14		6
#define AEM_CFG_AUDIO_CLUSTER_SIGNAL_OUTPUT_14		0
#define AEM_CFG_AUDIO_CLUSTER_PATH_LAT_14		0
#define AEM_CFG_AUDIO_CLUSTER_BLOCK_LAT_14		0
#define AEM_CFG_AUDIO_CLUSTER_CHAN_COUNT_14		2
#define AEM_CFG_AUDIO_CLUSTER_FORMAT_14			AEM_AUDIO_CLUSTER_FORMAT_MBLA

#define AEM_CFG_AUDIO_CLUSTER_NAME_15			"Audio cluster 15"
#define AEM_CFG_AUDIO_CLUSTER_LOC_DESC_15		7
#define AEM_CFG_AUDIO_CLUSTER_SIGNAL_TYPE_15		AEM_DESC_TYPE_EXTERNAL_PORT_INPUT
#define AEM_CFG_AUDIO_CLUSTER_SIGNAL_IDX_15		7
#define AEM_CFG_AUDIO_CLUSTER_SIGNAL_OUTPUT_15		0
#define AEM_CFG_AUDIO_CLUSTER_PATH_LAT_15		0
#define AEM_CFG_AUDIO_CLUSTER_BLOCK_LAT_15		0
#define AEM_CFG_AUDIO_CLUSTER_CHAN_COUNT_15		2
#define AEM_CFG_AUDIO_CLUSTER_FORMAT_15			AEM_AUDIO_CLUSTER_FORMAT_MBLA


#define AEM_CFG_AUDIO_CLUSTER_DESCRIPTORS {	\
						AEM_CFG_AUDIO_CLUSTER_DESCRIPTOR(0), AEM_CFG_AUDIO_CLUSTER_DESCRIPTOR(1), AEM_CFG_AUDIO_CLUSTER_DESCRIPTOR(2), AEM_CFG_AUDIO_CLUSTER_DESCRIPTOR(3),	\
						AEM_CFG_AUDIO_CLUSTER_DESCRIPTOR(4), AEM_CFG_AUDIO_CLUSTER_DESCRIPTOR(5), AEM_CFG_AUDIO_CLUSTER_DESCRIPTOR(6), AEM_CFG_AUDIO_CLUSTER_DESCRIPTOR(7),	\
						AEM_CFG_AUDIO_CLUSTER_DESCRIPTOR(8), AEM_CFG_AUDIO_CLUSTER_DESCRIPTOR(9), AEM_CFG_AUDIO_CLUSTER_DESCRIPTOR(10), AEM_CFG_AUDIO_CLUSTER_DESCRIPTOR(11),	\
						AEM_CFG_AUDIO_CLUSTER_DESCRIPTOR(12), AEM_CFG_AUDIO_CLUSTER_DESCRIPTOR(13), AEM_CFG_AUDIO_CLUSTER_DESCRIPTOR(14), AEM_CFG_AUDIO_CLUSTER_DESCRIPTOR(15)	\
					}


/* Audio map config */
#define AEM_CFG_AUDIO_MAP_NB_MAPPINGS_0		16
#define AEM_CFG_AUDIO_MAP_MAP_UNIT_0 		{\
							{	.mapping_stream_index = htons(0x0000),\
								.mapping_stream_channel = htons(0x0000),\
								.mapping_cluster_offset = htons(0x0000),\
								.mapping_cluster_channel = htons(0x0000)\
							},\
							{	.mapping_stream_index = htons(0x0000),\
								.mapping_stream_channel = htons(0x0001),\
								.mapping_cluster_offset = htons(0x0000),\
								.mapping_cluster_channel = htons(0x0001)\
							},\
							{	.mapping_stream_index = htons(0x0001),\
								.mapping_stream_channel = htons(0x0000),\
								.mapping_cluster_offset = htons(0x0001),\
								.mapping_cluster_channel = htons(0x0000)\
							},\
							{	.mapping_stream_index = htons(0x0001),\
								.mapping_stream_channel = htons(0x0001),\
								.mapping_cluster_offset = htons(0x0001),\
								.mapping_cluster_channel = htons(0x0001)\
							},\
							{	.mapping_stream_index = htons(0x0002),\
								.mapping_stream_channel = htons(0x0000),\
								.mapping_cluster_offset = htons(0x0002),\
								.mapping_cluster_channel = htons(0x0000)\
							},\
							{	.mapping_stream_index = htons(0x0002),\
								.mapping_stream_channel = htons(0x0001),\
								.mapping_cluster_offset = htons(0x0002),\
								.mapping_cluster_channel = htons(0x0001)\
							},\
							{	.mapping_stream_index = htons(0x0003),\
								.mapping_stream_channel = htons(0x0000),\
								.mapping_cluster_offset = htons(0x0003),\
								.mapping_cluster_channel = htons(0x0000)\
							},\
							{	.mapping_stream_index = htons(0x0003),\
								.mapping_stream_channel = htons(0x0001),\
								.mapping_cluster_offset = htons(0x0003),\
								.mapping_cluster_channel = htons(0x0001)\
							},\
							{	.mapping_stream_index = htons(0x0004),\
								.mapping_stream_channel = htons(0x0000),\
								.mapping_cluster_offset = htons(0x0004),\
								.mapping_cluster_channel = htons(0x0000)\
							},\
							{	.mapping_stream_index = htons(0x0004),\
								.mapping_stream_channel = htons(0x0001),\
								.mapping_cluster_offset = htons(0x0004),\
								.mapping_cluster_channel = htons(0x0001)\
							},\
							{	.mapping_stream_index = htons(0x0005),\
								.mapping_stream_channel = htons(0x0000),\
								.mapping_cluster_offset = htons(0x0005),\
								.mapping_cluster_channel = htons(0x0000)\
							},\
							{	.mapping_stream_index = htons(0x0005),\
								.mapping_stream_channel = htons(0x0001),\
								.mapping_cluster_offset = htons(0x0005),\
								.mapping_cluster_channel = htons(0x0001)\
							},\
							{	.mapping_stream_index = htons(0x0006),\
								.mapping_stream_channel = htons(0x0000),\
								.mapping_cluster_offset = htons(0x0006),\
								.mapping_cluster_channel = htons(0x0000)\
							},\
							{	.mapping_stream_index = htons(0x0006),\
								.mapping_stream_channel = htons(0x0001),\
								.mapping_cluster_offset = htons(0x0006),\
								.mapping_cluster_channel = htons(0x0001)\
							},\
							{	.mapping_stream_index = htons(0x0007),\
								.mapping_stream_channel = htons(0x0000),\
								.mapping_cluster_offset = htons(0x0007),\
								.mapping_cluster_channel = htons(0x0000)\
							},\
							{	.mapping_stream_index = htons(0x0007),\
								.mapping_stream_channel = htons(0x0001),\
								.mapping_cluster_offset = htons(0x0007),\
								.mapping_cluster_channel = htons(0x0001)\
							}\
						}

#define AEM_CFG_AUDIO_MAP_DESCRIPTORS {AEM_CFG_AUDIO_MAP_DESCRIPTOR(0)}


/* External port output config */
#define AEM_CFG_EXT_PORT_OUTPUT_CLK_DOM_IDX_0	0
#define AEM_CFG_EXT_PORT_OUTPUT_PORT_FLAGS_0	0
#define AEM_CFG_EXT_PORT_OUTPUT_NB_CONTROL_0	0
#define AEM_CFG_EXT_PORT_OUTPUT_BASE_CONTROL_0	0
#define AEM_CFG_EXT_PORT_OUTPUT_SIGNAL_TYPE_0	AEM_DESC_TYPE_CONTROL
#define AEM_CFG_EXT_PORT_OUTPUT_SIGNAL_IDX_0	0
#define AEM_CFG_EXT_PORT_OUTPUT_SIGNAL_OUTPUT_0	0
#define AEM_CFG_EXT_PORT_OUTPUT_BLOCK_LAT_0	100
#define AEM_CFG_EXT_PORT_OUTPUT_JACK_IDX_0	0

#define AEM_CFG_EXT_PORT_OUTPUT_CLK_DOM_IDX_1	0
#define AEM_CFG_EXT_PORT_OUTPUT_PORT_FLAGS_1	0
#define AEM_CFG_EXT_PORT_OUTPUT_NB_CONTROL_1	0
#define AEM_CFG_EXT_PORT_OUTPUT_BASE_CONTROL_1	0
#define AEM_CFG_EXT_PORT_OUTPUT_SIGNAL_TYPE_1	AEM_DESC_TYPE_AUDIO_CLUSTER
#define AEM_CFG_EXT_PORT_OUTPUT_SIGNAL_IDX_1	1
#define AEM_CFG_EXT_PORT_OUTPUT_SIGNAL_OUTPUT_1	0
#define AEM_CFG_EXT_PORT_OUTPUT_BLOCK_LAT_1	100
#define AEM_CFG_EXT_PORT_OUTPUT_JACK_IDX_1	1

#define AEM_CFG_EXT_PORT_OUTPUT_CLK_DOM_IDX_2	AEM_CFG_EXT_PORT_OUTPUT_CLK_DOM_IDX_1
#define AEM_CFG_EXT_PORT_OUTPUT_PORT_FLAGS_2	AEM_CFG_EXT_PORT_OUTPUT_PORT_FLAGS_1
#define AEM_CFG_EXT_PORT_OUTPUT_NB_CONTROL_2	AEM_CFG_EXT_PORT_OUTPUT_NB_CONTROL_1
#define AEM_CFG_EXT_PORT_OUTPUT_BASE_CONTROL_2	AEM_CFG_EXT_PORT_OUTPUT_BASE_CONTROL_1
#define AEM_CFG_EXT_PORT_OUTPUT_SIGNAL_TYPE_2	AEM_CFG_EXT_PORT_OUTPUT_SIGNAL_TYPE_1
#define AEM_CFG_EXT_PORT_OUTPUT_SIGNAL_IDX_2	2
#define AEM_CFG_EXT_PORT_OUTPUT_SIGNAL_OUTPUT_2	AEM_CFG_EXT_PORT_OUTPUT_SIGNAL_OUTPUT_1
#define AEM_CFG_EXT_PORT_OUTPUT_BLOCK_LAT_2	AEM_CFG_EXT_PORT_OUTPUT_BLOCK_LAT_1
#define AEM_CFG_EXT_PORT_OUTPUT_JACK_IDX_2	2

#define AEM_CFG_EXT_PORT_OUTPUT_CLK_DOM_IDX_3	AEM_CFG_EXT_PORT_OUTPUT_CLK_DOM_IDX_1
#define AEM_CFG_EXT_PORT_OUTPUT_PORT_FLAGS_3	AEM_CFG_EXT_PORT_OUTPUT_PORT_FLAGS_1
#define AEM_CFG_EXT_PORT_OUTPUT_NB_CONTROL_3	AEM_CFG_EXT_PORT_OUTPUT_NB_CONTROL_1
#define AEM_CFG_EXT_PORT_OUTPUT_BASE_CONTROL_3	AEM_CFG_EXT_PORT_OUTPUT_BASE_CONTROL_1
#define AEM_CFG_EXT_PORT_OUTPUT_SIGNAL_TYPE_3	AEM_CFG_EXT_PORT_OUTPUT_SIGNAL_TYPE_1
#define AEM_CFG_EXT_PORT_OUTPUT_SIGNAL_IDX_3	3
#define AEM_CFG_EXT_PORT_OUTPUT_SIGNAL_OUTPUT_3	AEM_CFG_EXT_PORT_OUTPUT_SIGNAL_OUTPUT_1
#define AEM_CFG_EXT_PORT_OUTPUT_BLOCK_LAT_3	AEM_CFG_EXT_PORT_OUTPUT_BLOCK_LAT_1
#define AEM_CFG_EXT_PORT_OUTPUT_JACK_IDX_3	3

#define AEM_CFG_EXT_PORT_OUTPUT_CLK_DOM_IDX_4	AEM_CFG_EXT_PORT_OUTPUT_CLK_DOM_IDX_1
#define AEM_CFG_EXT_PORT_OUTPUT_PORT_FLAGS_4	AEM_CFG_EXT_PORT_OUTPUT_PORT_FLAGS_1
#define AEM_CFG_EXT_PORT_OUTPUT_NB_CONTROL_4	AEM_CFG_EXT_PORT_OUTPUT_NB_CONTROL_1
#define AEM_CFG_EXT_PORT_OUTPUT_BASE_CONTROL_4	AEM_CFG_EXT_PORT_OUTPUT_BASE_CONTROL_1
#define AEM_CFG_EXT_PORT_OUTPUT_SIGNAL_TYPE_4	AEM_CFG_EXT_PORT_OUTPUT_SIGNAL_TYPE_1
#define AEM_CFG_EXT_PORT_OUTPUT_SIGNAL_IDX_4	4
#define AEM_CFG_EXT_PORT_OUTPUT_SIGNAL_OUTPUT_4	AEM_CFG_EXT_PORT_OUTPUT_SIGNAL_OUTPUT_1
#define AEM_CFG_EXT_PORT_OUTPUT_BLOCK_LAT_4	AEM_CFG_EXT_PORT_OUTPUT_BLOCK_LAT_1
#define AEM_CFG_EXT_PORT_OUTPUT_JACK_IDX_4	4

#define AEM_CFG_EXT_PORT_OUTPUT_CLK_DOM_IDX_5	AEM_CFG_EXT_PORT_OUTPUT_CLK_DOM_IDX_1
#define AEM_CFG_EXT_PORT_OUTPUT_PORT_FLAGS_5	AEM_CFG_EXT_PORT_OUTPUT_PORT_FLAGS_1
#define AEM_CFG_EXT_PORT_OUTPUT_NB_CONTROL_5	AEM_CFG_EXT_PORT_OUTPUT_NB_CONTROL_1
#define AEM_CFG_EXT_PORT_OUTPUT_BASE_CONTROL_5	AEM_CFG_EXT_PORT_OUTPUT_BASE_CONTROL_1
#define AEM_CFG_EXT_PORT_OUTPUT_SIGNAL_TYPE_5	AEM_CFG_EXT_PORT_OUTPUT_SIGNAL_TYPE_1
#define AEM_CFG_EXT_PORT_OUTPUT_SIGNAL_IDX_5	5
#define AEM_CFG_EXT_PORT_OUTPUT_SIGNAL_OUTPUT_5	AEM_CFG_EXT_PORT_OUTPUT_SIGNAL_OUTPUT_1
#define AEM_CFG_EXT_PORT_OUTPUT_BLOCK_LAT_5	AEM_CFG_EXT_PORT_OUTPUT_BLOCK_LAT_1
#define AEM_CFG_EXT_PORT_OUTPUT_JACK_IDX_5	5

#define AEM_CFG_EXT_PORT_OUTPUT_CLK_DOM_IDX_6	AEM_CFG_EXT_PORT_OUTPUT_CLK_DOM_IDX_1
#define AEM_CFG_EXT_PORT_OUTPUT_PORT_FLAGS_6	AEM_CFG_EXT_PORT_OUTPUT_PORT_FLAGS_1
#define AEM_CFG_EXT_PORT_OUTPUT_NB_CONTROL_6	AEM_CFG_EXT_PORT_OUTPUT_NB_CONTROL_1
#define AEM_CFG_EXT_PORT_OUTPUT_BASE_CONTROL_6	AEM_CFG_EXT_PORT_OUTPUT_BASE_CONTROL_1
#define AEM_CFG_EXT_PORT_OUTPUT_SIGNAL_TYPE_6	AEM_CFG_EXT_PORT_OUTPUT_SIGNAL_TYPE_1
#define AEM_CFG_EXT_PORT_OUTPUT_SIGNAL_IDX_6	6
#define AEM_CFG_EXT_PORT_OUTPUT_SIGNAL_OUTPUT_6	AEM_CFG_EXT_PORT_OUTPUT_SIGNAL_OUTPUT_1
#define AEM_CFG_EXT_PORT_OUTPUT_BLOCK_LAT_6	AEM_CFG_EXT_PORT_OUTPUT_BLOCK_LAT_1
#define AEM_CFG_EXT_PORT_OUTPUT_JACK_IDX_6	6

#define AEM_CFG_EXT_PORT_OUTPUT_CLK_DOM_IDX_7	AEM_CFG_EXT_PORT_OUTPUT_CLK_DOM_IDX_1
#define AEM_CFG_EXT_PORT_OUTPUT_PORT_FLAGS_7	AEM_CFG_EXT_PORT_OUTPUT_PORT_FLAGS_1
#define AEM_CFG_EXT_PORT_OUTPUT_NB_CONTROL_7	AEM_CFG_EXT_PORT_OUTPUT_NB_CONTROL_1
#define AEM_CFG_EXT_PORT_OUTPUT_BASE_CONTROL_7	AEM_CFG_EXT_PORT_OUTPUT_BASE_CONTROL_1
#define AEM_CFG_EXT_PORT_OUTPUT_SIGNAL_TYPE_7	AEM_CFG_EXT_PORT_OUTPUT_SIGNAL_TYPE_1
#define AEM_CFG_EXT_PORT_OUTPUT_SIGNAL_IDX_7	7
#define AEM_CFG_EXT_PORT_OUTPUT_SIGNAL_OUTPUT_7	AEM_CFG_EXT_PORT_OUTPUT_SIGNAL_OUTPUT_1
#define AEM_CFG_EXT_PORT_OUTPUT_BLOCK_LAT_7	AEM_CFG_EXT_PORT_OUTPUT_BLOCK_LAT_1
#define AEM_CFG_EXT_PORT_OUTPUT_JACK_IDX_7	7

#define AEM_CFG_EXT_PORT_OUTPUT_DESCRIPTORS {	\
						AEM_CFG_EXT_PORT_OUTPUT_DESCRIPTOR(0), AEM_CFG_EXT_PORT_OUTPUT_DESCRIPTOR(1), AEM_CFG_EXT_PORT_OUTPUT_DESCRIPTOR(2), AEM_CFG_EXT_PORT_OUTPUT_DESCRIPTOR(3),	\
						AEM_CFG_EXT_PORT_OUTPUT_DESCRIPTOR(4), AEM_CFG_EXT_PORT_OUTPUT_DESCRIPTOR(5), AEM_CFG_EXT_PORT_OUTPUT_DESCRIPTOR(6), AEM_CFG_EXT_PORT_OUTPUT_DESCRIPTOR(7)	\
					}


/* External port input config */
#define AEM_CFG_EXT_PORT_INPUT_CLK_DOM_IDX_0	0
#define AEM_CFG_EXT_PORT_INPUT_PORT_FLAGS_0	0
#define AEM_CFG_EXT_PORT_INPUT_NB_CONTROL_0	0
#define AEM_CFG_EXT_PORT_INPUT_BASE_CONTROL_0	0
#define AEM_CFG_EXT_PORT_INPUT_SIGNAL_TYPE_0	AEM_DESC_TYPE_INVALID
#define AEM_CFG_EXT_PORT_INPUT_SIGNAL_IDX_0	0
#define AEM_CFG_EXT_PORT_INPUT_SIGNAL_OUTPUT_0	0
#define AEM_CFG_EXT_PORT_INPUT_BLOCK_LAT_0	100
#define AEM_CFG_EXT_PORT_INPUT_JACK_IDX_0	0

#define AEM_CFG_EXT_PORT_INPUT_CLK_DOM_IDX_1	0
#define AEM_CFG_EXT_PORT_INPUT_PORT_FLAGS_1	0
#define AEM_CFG_EXT_PORT_INPUT_NB_CONTROL_1	0
#define AEM_CFG_EXT_PORT_INPUT_BASE_CONTROL_1	0
#define AEM_CFG_EXT_PORT_INPUT_SIGNAL_TYPE_1	AEM_DESC_TYPE_INVALID
#define AEM_CFG_EXT_PORT_INPUT_SIGNAL_IDX_1	0
#define AEM_CFG_EXT_PORT_INPUT_SIGNAL_OUTPUT_1	0
#define AEM_CFG_EXT_PORT_INPUT_BLOCK_LAT_1	100
#define AEM_CFG_EXT_PORT_INPUT_JACK_IDX_1	1


#define AEM_CFG_EXT_PORT_INPUT_CLK_DOM_IDX_2	0
#define AEM_CFG_EXT_PORT_INPUT_PORT_FLAGS_2	0
#define AEM_CFG_EXT_PORT_INPUT_NB_CONTROL_2	0
#define AEM_CFG_EXT_PORT_INPUT_BASE_CONTROL_2	0
#define AEM_CFG_EXT_PORT_INPUT_SIGNAL_TYPE_2	AEM_DESC_TYPE_INVALID
#define AEM_CFG_EXT_PORT_INPUT_SIGNAL_IDX_2	0
#define AEM_CFG_EXT_PORT_INPUT_SIGNAL_OUTPUT_2	0
#define AEM_CFG_EXT_PORT_INPUT_BLOCK_LAT_2	100
#define AEM_CFG_EXT_PORT_INPUT_JACK_IDX_2	2

#define AEM_CFG_EXT_PORT_INPUT_CLK_DOM_IDX_3	0
#define AEM_CFG_EXT_PORT_INPUT_PORT_FLAGS_3	0
#define AEM_CFG_EXT_PORT_INPUT_NB_CONTROL_3	0
#define AEM_CFG_EXT_PORT_INPUT_BASE_CONTROL_3	0
#define AEM_CFG_EXT_PORT_INPUT_SIGNAL_TYPE_3	AEM_DESC_TYPE_INVALID
#define AEM_CFG_EXT_PORT_INPUT_SIGNAL_IDX_3	0
#define AEM_CFG_EXT_PORT_INPUT_SIGNAL_OUTPUT_3	0
#define AEM_CFG_EXT_PORT_INPUT_BLOCK_LAT_3	100
#define AEM_CFG_EXT_PORT_INPUT_JACK_IDX_3	3

#define AEM_CFG_EXT_PORT_INPUT_CLK_DOM_IDX_4	0
#define AEM_CFG_EXT_PORT_INPUT_PORT_FLAGS_4	0
#define AEM_CFG_EXT_PORT_INPUT_NB_CONTROL_4	0
#define AEM_CFG_EXT_PORT_INPUT_BASE_CONTROL_4	0
#define AEM_CFG_EXT_PORT_INPUT_SIGNAL_TYPE_4	AEM_DESC_TYPE_INVALID
#define AEM_CFG_EXT_PORT_INPUT_SIGNAL_IDX_4	0
#define AEM_CFG_EXT_PORT_INPUT_SIGNAL_OUTPUT_4	0
#define AEM_CFG_EXT_PORT_INPUT_BLOCK_LAT_4	100
#define AEM_CFG_EXT_PORT_INPUT_JACK_IDX_4	0

#define AEM_CFG_EXT_PORT_INPUT_CLK_DOM_IDX_5	0
#define AEM_CFG_EXT_PORT_INPUT_PORT_FLAGS_5	0
#define AEM_CFG_EXT_PORT_INPUT_NB_CONTROL_5	0
#define AEM_CFG_EXT_PORT_INPUT_BASE_CONTROL_5	0
#define AEM_CFG_EXT_PORT_INPUT_SIGNAL_TYPE_5	AEM_DESC_TYPE_INVALID
#define AEM_CFG_EXT_PORT_INPUT_SIGNAL_IDX_5	0
#define AEM_CFG_EXT_PORT_INPUT_SIGNAL_OUTPUT_5	0
#define AEM_CFG_EXT_PORT_INPUT_BLOCK_LAT_5	100
#define AEM_CFG_EXT_PORT_INPUT_JACK_IDX_5	1


#define AEM_CFG_EXT_PORT_INPUT_CLK_DOM_IDX_6	0
#define AEM_CFG_EXT_PORT_INPUT_PORT_FLAGS_6	0
#define AEM_CFG_EXT_PORT_INPUT_NB_CONTROL_6	0
#define AEM_CFG_EXT_PORT_INPUT_BASE_CONTROL_6	0
#define AEM_CFG_EXT_PORT_INPUT_SIGNAL_TYPE_6	AEM_DESC_TYPE_INVALID
#define AEM_CFG_EXT_PORT_INPUT_SIGNAL_IDX_6	0
#define AEM_CFG_EXT_PORT_INPUT_SIGNAL_OUTPUT_6	0
#define AEM_CFG_EXT_PORT_INPUT_BLOCK_LAT_6	100
#define AEM_CFG_EXT_PORT_INPUT_JACK_IDX_6	2

#define AEM_CFG_EXT_PORT_INPUT_CLK_DOM_IDX_7	0
#define AEM_CFG_EXT_PORT_INPUT_PORT_FLAGS_7	0
#define AEM_CFG_EXT_PORT_INPUT_NB_CONTROL_7	0
#define AEM_CFG_EXT_PORT_INPUT_BASE_CONTROL_7	0
#define AEM_CFG_EXT_PORT_INPUT_SIGNAL_TYPE_7	AEM_DESC_TYPE_INVALID
#define AEM_CFG_EXT_PORT_INPUT_SIGNAL_IDX_7	0
#define AEM_CFG_EXT_PORT_INPUT_SIGNAL_OUTPUT_7	0
#define AEM_CFG_EXT_PORT_INPUT_BLOCK_LAT_7	100
#define AEM_CFG_EXT_PORT_INPUT_JACK_IDX_7	3

#define AEM_CFG_EXT_PORT_INPUT_DESCRIPTORS {	\
						AEM_CFG_EXT_PORT_INPUT_DESCRIPTOR(0), AEM_CFG_EXT_PORT_INPUT_DESCRIPTOR(1), AEM_CFG_EXT_PORT_INPUT_DESCRIPTOR(2), AEM_CFG_EXT_PORT_INPUT_DESCRIPTOR(3), \
						AEM_CFG_EXT_PORT_INPUT_DESCRIPTOR(4), AEM_CFG_EXT_PORT_INPUT_DESCRIPTOR(5), AEM_CFG_EXT_PORT_INPUT_DESCRIPTOR(6), AEM_CFG_EXT_PORT_INPUT_DESCRIPTOR(7)	\
					}

#define AEM_CFG_CONTROL_NAME_0			"Volume Control 0"
#define AEM_CFG_CONTROL_LOC_DESC_0		7
#define AEM_CFG_CONTROL_BLOCK_LAT_0		0
#define AEM_CFG_CONTROL_CTRL_LAT_0		200
#define AEM_CFG_CONTROL_DOMAIN_0		0
#define AEM_CFG_CONTROL_VALUE_TYPE_0		AEM_CONTROL_SET_VALUE_TYPE(0, 0, AEM_CONTROL_LINEAR_UINT8)
#define AEM_CFG_CONTROL_TYPE_0			AEM_CONTROL_TYPE_GAIN
#define AEM_CFG_CONTROL_RESET_TIME_0		0
#define AEM_CFG_CONTROL_NB_VALUES_0		1
#define AEM_CFG_CONTROL_SIGNAL_TYPE_0		AEM_DESC_TYPE_AUDIO_CLUSTER
#define AEM_CFG_CONTROL_SIGNAL_INDEX_0		0
#define AEM_CFG_CONTROL_SIGNAL_OUTPUT_0		0
#define AEM_CFG_CONTROL_VALUE_DETAILS_0		{\
		.linear_int8 = {{0, 100, 1, 50, 100, htons(AEM_CONTROL_SET_UNIT_FORMAT(0, AEM_CONTROL_CODE_PERCENT)), 0}}}


#define AEM_CFG_CONTROL_DESCRIPTORS {AEM_CFG_CONTROL_DESCRIPTOR(0)}

#include "genavb/aem_entity.h"

#endif /* _TALKER_LISTENER_AUDIO_MULTI_AAF_H_ */
