if(NOT DEFINED BIN_DIR)
  message(FATAL_ERROR "BIN_DIR not defined")
endif()

if(NOT DEFINED INITSCRIPT_DIR)
  message(FATAL_ERROR "INITSCRIPT_DIR not defined")
endif()

function(avb_script_install package_string)
  install(PROGRAMS ${CMAKE_CURRENT_LIST_DIR}/avb.sh DESTINATION ${BIN_DIR})
  install(CODE "execute_process(COMMAND sed -i \"/PACKAGE=/cPACKAGE=${package_string}\" \$ENV{DESTDIR}/${CMAKE_INSTALL_PREFIX}/${BIN_DIR}/avb.sh)")
  install(PROGRAMS ${CMAKE_CURRENT_LIST_DIR}/tsn.sh DESTINATION ${BIN_DIR})
  install(CODE "execute_process(COMMAND sed -i \"/PACKAGE=/cPACKAGE=${package_string}\" \$ENV{DESTDIR}/${CMAKE_INSTALL_PREFIX}/${BIN_DIR}/tsn.sh)")
  # Backward compatibility
  install(CODE "execute_process(COMMAND ln -rsf \$ENV{DESTDIR}/${CMAKE_INSTALL_PREFIX}/${BIN_DIR}/tsn.sh \$ENV{DESTDIR}/${CMAKE_INSTALL_PREFIX}/${BIN_DIR}/fgptp.sh)")
endfunction()

if(${CONFIG} STREQUAL "endpoint_avb")
  avb_script_install("ENDPOINT")
  install(PROGRAMS ${CMAKE_CURRENT_LIST_DIR}/init.sh DESTINATION ${INITSCRIPT_DIR} RENAME genavb)
elseif(${CONFIG} STREQUAL "endpoint_tsn" OR ${CONFIG} STREQUAL "endpoint_avb_tsn")
  avb_script_install("ENDPOINT")
  install(PROGRAMS ${CMAKE_CURRENT_LIST_DIR}/init.sh DESTINATION ${INITSCRIPT_DIR} RENAME genavb)
  install(PROGRAMS ${CMAKE_CURRENT_LIST_DIR}/tsn-app-setup.sh DESTINATION ${BIN_DIR})
elseif(${CONFIG} STREQUAL "bridge")
  avb_script_install("BRIDGE")
  install(PROGRAMS ${CMAKE_CURRENT_LIST_DIR}/init.sh DESTINATION ${INITSCRIPT_DIR} RENAME genavb)
  install(PROGRAMS ${CMAKE_CURRENT_LIST_DIR}/avb-bridge.sh DESTINATION ${BIN_DIR})
endif()
